document.addEventListener("DOMContentLoaded", (event) => {
	
	console.log(performance.now(),"dom loaded");
	let libs={};

	let custo=new CustomElementObserver({
		rules:[
			{tag:'body',observeChildren:true},
		],
		checkErrorTimeout:10000,
		onRegister:function (tags) {
			for(let i=0; i<tags.length; i++){
				let t=tags[i];
				console.log(performance.now(),'onreg',tags);
				let lib=t.split('-')[1];
				let path=`/controls/${lib}/lib.js`;

				if(!libs[lib]){
					libs[lib]=true;
					console.log(performance.now(),'load',tags);
					Util.loadjss([path],function (res,err){
						console.log(performance.now(),"control loaded");
						let unreg=custo.getUnregistered();
						for(let i=0; i<unreg.length; i++){
							let t=unreg[i];
							if(t.startsWith(`control-${lib}-`)){
								console.log('unregistered',t);
							}
						}
					});
				}

			}
		},
		onComplete:function (){
			console.log(performance.now(),'oncomplete');
		},
		onError:function (tags){
			console.log(performance.now(),'onerror',tags);
		}
	});
	custo.observe(document.body);
	
	let button=document.createElement('control-common-button1');
	document.body.appendChild(button);

	let arrow=document.createElement('control-common-arrow1');
	document.body.appendChild(arrow);

	let a=[];
	for(let y=0; y<50; y++){
		for(let x=0; x<100; x++){
			a.push(`<control-common-label1 position='absolute' left='${x*20}' top='${y*10}' height='10' text_size='7' width='20' value='$node${y+1}.vars.var${x+1}'></control-common-label1>`);
			//a.push(`<div style='position:absolute; left:${x*20}px; top:${y*10}px; height:10px; width:20px; font-size:7px'>$node${y+1}.vars.var${x+1}</div>`);
		}
		//a.push(`"param_object_node${y+1}": "Узел${y+1}.node",`);
	}
	console.log(a.join('\n'));



});