/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Шлюз";
  var $nodes="Узлы";
  var $journal="Журнал";
  var $vars="Переменные";
  var $noproto="К шлюзу не привязан прототип";
  var $noproto_desc="Укажите прототип в свойствах шлюза в редакторе проектов";
  var $reports="Отчеты";
  var $logs="Логи";
  var $noproto_link="Редактировать шлюз";
  var $reports="Отчеты";
  var $gateway_params="Параметры шлюза";
}else{
  var $title="Gateway";
  var $nodes="Nodes";
  var $journal="Journal";
  var $vars="Variables";
  var $noproto="There is no prototype associated with the gateway";
  var $noproto_desc="Specify the prototype in the gateway properties in the project editor";
  var $noproto_link="Edit gateway";
  var $reports="Reports";
  var $logs="Logs";
  var $reports="Reports";
  var $gateway_params="Gateway params";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<a-layout id="gateway_layout1" orientation="vertical" store="true" size1="400" stretch="slot2">
	<a-layout id="gateway_layout2" orientation="horizontal" size1="400" stretch="slot2" store="true" slot="1">
		<a-widget id="info" prefix="info" slot="1"></a-widget>
	    <a-widget id="nodes" prefix="nodes" slot="2"></a-widget>
	</a-layout>
	<a-layout id="gateway_layout3" orientation="horizontal" size1="400" stretch="slot2" store="true" slot="2">
      	<a-widget id="params"  prefix="params" slot="1"></a-widget>
	    <a-widget id="vars"  prefix="vars" slot="2"></a-widget>
	</a-layout>
</a-layout>
`,
);

PROPERTIES={
	path:{
		type:'string',
		propagate:false,
	},
};


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

function create(){
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
}


function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}



function update_path(path){

	pult.unsubscribeStatusVar(self);
	
	pult.showObject(self,self.path,null,function (o){

		pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});

		if(o.prototype){

			pult.showAlarms(self,!o.hide_alarm_panel && !!o._alarms);
			dom.info.src=`#interface/gateway_info?path=${o._path}&show_name=false&caption_link=%self_path%`;
			dom.nodes.src=`#interface/browser?path=${o._path}&show_name=false&caption_link=%self_path%&caption=${$nodes}`;
			dom.params.src=`#interface/node_params?path=${o._path}&show_name=false&caption_link=%self_path%&caption=${$gateway_params}`;
			dom.vars.src=`#interface/vars?path=${o._path}&show_name=false&caption_link=%self_path%`;

			pult.loadObject(self,{
				path:`${pult.getProjectPath(o._path)}/prototypes/${o.prototype}`,
				docs:'@content.json'
			},function (p){
				let content=p?.['@content.json'].data;
				let reports=content?.reports;

				let menu=[];

				menu.push({
					text:$journal,
					icon:'/images/journal.svg',
					href:'#interface/journal?path='+self.path,
				},);
				
				menu.push({
					text:$logs,
					icon:'/images/log.svg',
					href:'#interface/logs?path='+self.path,
				});
				
				menu.push({
					text:$vars,
					icon:'/images/var.svg',
					href:'#interface/vars?path='+self.path,
				});
			
				if(reports?.length){
					menu.push({
						text:$reports,
						icon:'/images/report.svg',
						href:'#interface/node_report?path='+self.path,
					});
				}

				pult.showTopMenu(self,menu);

			});

		}else{
			pult.showModalError(self,$noproto,$noproto_desc,$noproto_link,o._editor,'editor');
		}
	});


}
