/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $caption="Информация о шлюзе";
  var $online="Подключен";
  var $offline="Отключен";
  var $version="Версия";
  var $remote_ip="Внешний IP";
  var $local_ip="Локальные IP";
}else{
  var $caption="Gateway information";
  var $online="Connected";
  var $offline="Disconnected";
  var $version="Version";
  var $remote_ip="External IP";
  var $local_ip="Local IP";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<a-card id="card"></a-card>`,
);

PROPERTIES={
	path:{
		type:'string',
        propagate:false,
	},
};


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

function create(){
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}

function update_path(path){
    pult.unsubscribeStatusVar(self);
	pult.showObject(self,self.path,$caption,function (o){
        pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});
    });
	loadData();
}


function loadData(){

    pult.request(self,'gateway_info',{path:self.path},function (req,res,err){
        if(err){
            pult.showModalError(self,err);
        }else{

            let g=res;

            g._version=g.version_number ? g.version_number+' / '+g.version_date : undefined;
            g._local_ip=g.local_ip ? g.local_ip.join(', ') : undefined;

            dom.card.schema=[
                {
                    key:'mac',
                    caption: 'MAC',
                },
                {
                    key:'_version',
                    caption: $version,
                },
                {
                    key:'online',
                    caption: $online,
                    format:'$datetimelong'
                },
                {
                    key:'offline',
                    caption: $offline,
                    format:'$datetimelong'
                },
                {
                    key:'remote_ip',
                    caption: $remote_ip,
                },
                {
                    key:'_local_ip',
                    caption: $local_ip,
                },
            ];
            dom.card.data=g;
        }
    });
}
