(function () {

	let template = createTemplate(
		`a-widget{height:50%}`,
		`<h1 id="header">MIMIC</h1>
<a-widget src="#interface/mimic1" prefix="mimic1"></a-widget>
<a-widget src="#interface/mimic2" prefix="mimic2"></a-widget>`,
	);

	Util.registerCustomElement(class widgetInterfaceMimic extends aNode{

		static get properties(){
			return Util.merge(super.properties,{
				path:{
					type:'string',
				},
				show_header:{
					type:'boolean',
					default:true,
				},
			});
		}

		create(){
			let self=this;
			super.create();
			self.append(template);
		}

		update_show_header(){
			let self=this;
			self.dom.header.style.display=self.__show_header?'block':'none';
			console.log('update header',self.show_header);
		}
	   

	});

})();
