/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $editor='Редактор';
	var $buildlog='Лог сборки';
	var $buildlog_desc='Лог процесса сборки проектов';
	var $no_data='Нет данных';
	
}else{
	var $editor='Editor';
	var $buildlog='Build log';
	var $buildlog_desc='Project build process log';
	var $no_data='No data';
}
  

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	`#_editor_content{padding:20px}`,
	`<div id="empty" class="pult_empty">${$no_data}</div>
<div id="list"></div>`,
);

ONCREATE=create;

let editor;

function create(){

	editor=self.editor;
	//console.log('create');
	editor.showTitle($buildlog,'/images/buildlog.svg');
	editor.showDescription($buildlog_desc);
	editor.showPath([[$editor,'#editor/home'],[$buildlog,'#editor/buildlog']]);

	editor.showProperties(null);

	editor.onBuildLog=function (log){
		dom.empty.style.display='none';
		let d;
		for(let i=0; i<log.length; i++){
			let l=log[i];
			d=document.createElement('div');
			d.innerText=l;
			if(l.includes('error:')){
				d.classList.add('error');
			}
			dom.list.appendChild(d);
		}
		if(d) d.scrollIntoView();
	}

	let log=editor.workspace.build_log;
	editor.onBuildLog(log);

}

