(function () {

  let template = createTemplate(
    ``,
    `<div>
    <control-common-rect1
			background_color="transparent"
			height="100%"
			style_text="display:flex;
flex-direction:row;
"
			width="100%">
			<control-common-rect1
				background_color="transparent"
				height="100%"
				style_text="flex-shrink:0;"
				width="1120">
				<control-common-rect1
					background_color="transparent"
					border_color="#212631"
					border_right_width="1"
					display="inline-block"
					height="100%"
					width="300">
					<control-mobile-header1
						name="Связь">
					</control-mobile-header1>
					<control-mobile-lamp1
						border_bottom_width="1"
						border_color="#212631"
						name="Шлюз онлайн"
						on_color="#9EBCFF"
						size="15"
						value="$node.vars.metric_online.status">
					</control-mobile-lamp1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Пинг"
						suffix=" мс"
						value="$node.vars.metric_ping.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Подключен"
						value="{{if($node.vars.metric_online.status,datetime($node.vars.metric_online.time),'-')}}"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Отключен"
						value="{{if($node.vars.metric_online.status,'-',datetime($node.vars.metric_offline.time))}}"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-header1
						name="Сводная информация">
					</control-mobile-header1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Координаты"
						value="{{$node.vars.gpsd_lat.status}} {{$node.vars.gpsd_lon.status}}"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						list="1:Ручной,*:Авто"
						name="Ручной / Авто"
						value="$node.vars.deif_ManMode.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						list="1:Closed,*:Opened"
						name="ACB"
						value="$node.vars.deif_CBclosed.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Моточасы"
						suffix=" ч"
						value="{{round(($node.vars.deif_SMR_b.status / 1440 + $node.vars.deif_SMR_a.status) *24)}}"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Активная энергия"
						suffix=" кВт*ч"
						value="$node.vars.deif_EnergyP.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Версия DEIF"
						value="$node.vars.deif_SwVer.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-common-rect1
						background_color="transparent"
						display="block"
						height="150"
						width="100%">
						<control-common-rect1
							background_color="transparent"
							height="150"
							left="0px"
							position="absolute"
							width="50%">
							<control-mobile-header1
								name="Аккумулятор"
								text_align="center">
							</control-mobile-header1>
							<control-common-gauge1
								arrow_color="#D0D0DD"
								label_color="#666666"
								level1_color="#CC0000"
								level1_show_sector="0"
								level1_value="0"
								level2_color="#D0D0DD"
								level2_show_sector="1"
								level2_value="24"
								level3_color="#CC0000"
								level3_show_sector="0"
								level3_value="28"
								margin_left="-2"
								max_value="32"
								position=""
								round="1"
								scale_color="#666666"
								scale_width="0"
								suffix=" В"
								value="$node.vars.deif_Ubatt.status"
								value_color="#D0D0F8"
								value_size="10"
								width="150">
							</control-common-gauge1>
						</control-common-rect1>
						<control-common-rect1
							background_color="transparent"
							height="150"
							left="50%"
							position="absolute"
							top="0px"
							width="49%">
							<control-mobile-header1
								name="Бак"
								text_align="center">
							</control-mobile-header1>
							<control-common-gauge1
								arrow_color="#D0D0DD"
								label_color="#666666"
								left="-2"
								level1_color="#CC0000"
								level1_show_sector="1"
								level1_value="0"
								level2_show_sector="0"
								level2_value="25"
								margin_left="-4"
								max_value="100"
								round="1"
								scale_color="#666666"
								scale_width="0"
								suffix="%"
								value="$node.vars.display_Level_DUT_perc.status"
								value_color="#D0D0F8"
								value_size="10"
								width="150">
							</control-common-gauge1>
						</control-common-rect1>
					</control-common-rect1>
					<control-mobile-header1
						name="ЭНЕРГИЯ СО СБРОСА">
					</control-mobile-header1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Активная энергия"
						suffix=" МВт*ч "
						value="$node.vars.mac_A.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Реактивная энергия"
						suffix=" МВАр*ч"
						value="$node.vars.mac_R.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-header1
						name="Топливо">
					</control-mobile-header1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Запас топлива"
						suffix=" л"
						value="$node.vars.display_Level_DUT_l.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Температура топлива"
						suffix=" °C"
						value="$node.vars.display_Temp_Fuel.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Скорость подачи"
						suffix=" л/ч"
						value="$node.vars.display_Speed_DRT.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Скорость обратки"
						suffix=" л/ч"
						value="$node.vars.display_Speed_DRT_obr.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Накопленный объем подачи"
						suffix=" л"
						value="$node.vars.display_Vol_DRT_total.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Накопленный объем обратки"
						suffix=" л"
						value="$node.vars.display_Vol_DRT_total_obr.status"
						value_color="#D0D0F8">
					</control-mobile-label1>
					<control-mobile-label1
						border_bottom_width="1"
						border_color="#212631"
						name="Объемный расход топлива"
						suffix=" л/ч"
						text_bold="1"
						value="{{round($node.vars.display_Speed_DRT.status - $node.vars.display_Speed_DRT_obr.status)}}"
						value_bold="1"
						value_color="#D0D0F8">
					</control-mobile-label1>
				</control-common-rect1>
				<control-common-rect1
					background_color="transparent"
					display="inline-block"
					height="100%"
					left="300"
					position="absolute"
					top="0"
					width="840">
					<control-common-rect1
						background_color="transparent"
						border_color="#212631"
						border_left_width="1"
						border_right_width="1"
						display="inline-block"
						height="100%"
						left="3"
						position="absolute"
						top="0"
						width="280">
						<control-mobile-header1
							name="Токи"
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L1, А">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="2000"
									scale_color="#678"
									value="$node.vars.deif_IL1.status"
									value_color="#996633">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L2, А">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="2000"
									scale_color="#678"
									value="$node.vars.deif_IL2.status"
									value_color="#996633">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L3, А">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="2000"
									scale_color="#678"
									value="$node.vars.deif_IL3.status"
									value_color="#996633">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
						<control-mobile-header1
							name="Напряжение генератора лин."
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L1L2, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UL1L2.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L2L3, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UL2L3.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L3L1, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UL3L1.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
						<control-mobile-header1
							name="Напряжение шины лин."
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L1L2, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UbusL1L2.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L2L3, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UbusL2L3.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L3L1, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="500"
									scale_color="#678"
									value="$node.vars.deif_UbusL3L1.status"
									value_color="#0099FF">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
					</control-common-rect1>
					<control-common-rect1
						background_color="transparent"
						border_color="#212631"
						border_left_width="1"
						border_right_width="1"
						display="inline-block"
						height="100%"
						left="559"
						position="absolute"
						top="0"
						width="280">
						<control-mobile-header1
							name="МОЩНОСТЬ"
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="P, КВТ">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="1200"
									scale_color="#678"
									value="$node.vars.deif_P.status"
									value_color="#00AA33">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="Q, КВАР">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="1200"
									scale_color="#678"
									value="$node.vars.deif_Q.status"
									value_color="#00AA33">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="S, КВА">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="1200"
									scale_color="#678"
									value="$node.vars.deif_S.status"
									value_color="#00AA33">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
						<control-mobile-header1
							name="НАПРЯЖЕНИЕ ГЕНЕРАТОРА ФАЗН."
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L1N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UL1.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L2N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UL2.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L3N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UL3.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
						<control-mobile-header1
							name="НАПРЯЖЕНИЕ ШИНЫ ФАЗН."
							padding_left="30">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							padding_left="20"
							top="10"
							width="100%">
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L1N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UbusL1.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L2N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UbusL2.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
							<control-common-rect1
								background_color="transparent"
								height="300"
								left="0"
								top="0"
								width="80">
								<control-mobile-header1
									background_color="transparent"
									name="L3N, В">
								</control-mobile-header1>
								<control-common-level1
									label_color="#678"
									left="10"
									max_value="300"
									scale_color="#678"
									value="$node.vars.deif_UbusL3.status"
									value_color="#3366BB">
								</control-common-level1>
							</control-common-rect1>
						</control-common-rect1>
					</control-common-rect1>
					<control-common-rect1
						background_color="transparent"
						border_color="#212631"
						border_left_width="1"
						border_right_width="1"
						display="inline-block"
						height="100%"
						left="286"
						position="absolute"
						top="0"
						width="270">
						<control-mobile-header1
							name="КОЭФ. МОЩНОСТИ"
							text_align="center">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							top="0"
							width="100%">
							<control-mobile-header1
								background_color="transparent"
								name="cos ⁡ φ"
								text_align="center"
								text_uppercase="0"
								top="40">
							</control-mobile-header1>
							<control-common-gaugepf1
								arrow_color="#D0D0DD"
								display="inline-block"
								label_color="#666666"
								label_size="6"
								left="25"
								max_value="1"
								min_value="-1"
								position=""
								round="2"
								scale_color="#666666"
								scale_width="1"
								top="58"
								value="$node.vars.deif_pf.status"
								value_color="#D0D0DD"
								value_size="9"
								width="220">
							</control-common-gaugepf1>
						</control-common-rect1>
						<control-mobile-header1
							name="ЧАСТОТА ГЕНЕРАТОРА"
							text_align="center">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							top="0"
							width="100%">
							<control-mobile-header1
								background_color="transparent"
								name="Гц"
								text_align="center"
								text_uppercase="0"
								top="40">
							</control-mobile-header1>
							<control-common-gauge1
								arrow_color="#D0D0DD"
								display="inline-block"
								label_color="#666666"
								label_size="6"
								left="25"
								max_value="100"
								min_value="0"
								position=""
								round="2"
								scale_color="#666666"
								scale_width="0"
								top="58"
								value="$node.vars.deif_f.status"
								value_color="#D0D0DD"
								value_size="9"
								width="220">
							</control-common-gauge1>
						</control-common-rect1>
						<control-mobile-header1
							name="ЧАСТОТА ШИНЫ"
							text_align="center">
						</control-mobile-header1>
						<control-common-rect1
							background_color="transparent"
							display="block"
							height="300"
							left="0"
							top="0"
							width="100%">
							<control-mobile-header1
								background_color="transparent"
								name="Гц"
								text_align="center"
								text_uppercase="0"
								top="40">
							</control-mobile-header1>
							<control-common-gauge1
								arrow_color="#D0D0DD"
								display="inline-block"
								label_color="#666666"
								label_size="6"
								left="25"
								max_value="100"
								min_value="0"
								position=""
								round="2"
								scale_color="#666666"
								scale_width="0"
								top="58"
								value="$node.vars.deif_fbus.status"
								value_color="#D0D0DD"
								value_size="9"
								width="220">
							</control-common-gauge1>
						</control-common-rect1>
					</control-common-rect1>
				</control-common-rect1>
			</control-common-rect1>
			<control-common-rect1
				background_color="transparent"
				border_color="#212631"
				border_left_width="1"
				display="inline-block"
				height="100%"
				margin_left="5px"
				width="100%">
				<control-common-rect1
					background_color="transparent"
					display="block"
					height="32"
					width="100%">
					<control-mobile-header1
						name="Мощность"
						padding_left="10">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="80"
						name="P ---"
						position="absolute"
						text_bold="1"
						text_color="red"
						top="0"
						width="60">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="130"
						name="Q ---"
						position="absolute"
						text_bold="1"
						text_color="#6666FF"
						top="0"
						width="60">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="240"
						name="cos ⁡φ ---"
						position="absolute"
						text_bold="1"
						text_color="#CCC"
						top="0"
						width="90">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="180"
						name="S ---"
						position="absolute"
						text_bold="1"
						text_color="green"
						top="0"
						width="60">
					</control-mobile-header1>
				</control-common-rect1>
				<control-common-trend1
					autoscale1="2"
					autoscale2="2"
					color1="red"
					color2="#6666FF"
					color3="green"
					height="220"
					left_padding="50"
					left_scale_color="#AAAAAA"
					name1="P"
					name2="Q"
					name3="S"
					timeline="0"
					value1="$node.vars.deif_P.update"
					value2="$node.vars.deif_Q.update"
					value3="$node.vars.deif_S.update">
				</control-common-trend1>
				<control-common-trend1
					border_color="#212631"
					border_top_width="1"
					color1="#AAAAAA"
					height="80"
					left_padding="50"
					name1="cos ⁡φ"
					value1="$node.vars.deif_pf.update">
				</control-common-trend1>
				<control-common-rect1
					background_color="transparent"
					display="block"
					height="32"
					width="100%">
					<control-mobile-header1
						name="Токи"
						padding_left="10">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="50"
						name="L1 ---"
						position="absolute"
						text_bold="1"
						text_color="red"
						top="0"
						width="70">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="100"
						name="L2 ---"
						position="absolute"
						text_bold="1"
						text_color="green"
						top="0"
						width="70">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="150"
						name="L3 ---"
						position="absolute"
						text_bold="1"
						text_color="#6666FF"
						top="0"
						width="90">
					</control-mobile-header1>
				</control-common-rect1>
				<control-common-trend1
					color1="red"
					color2="green"
					color3="#6666FF"
					height="300"
					left_padding="50"
					left_scale_color="#AAAAAA"
					name1="L1"
					name2="L2"
					name3="L3"
					timeline="1"
					value1="$node.vars.deif_IL1.update"
					value2="$node.vars.deif_IL2.update"
					value3="$node.vars.deif_IL3.update">
				</control-common-trend1>
				<control-common-rect1
					background_color="transparent"
					display="block"
					height="32"
					width="100%">
					<control-mobile-header1
						name="НАПРЯЖЕНИЯ ШИНЫ ЛИН."
						padding_left="10">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="160"
						name="L1L2 ---"
						position="absolute"
						text_bold="1"
						text_color="red"
						top="0"
						width="90">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="230"
						name="L2L3 ---"
						position="absolute"
						text_bold="1"
						text_color="green"
						top="0"
						width="90">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="300"
						name="L3L1 ---"
						position="absolute"
						text_bold="1"
						text_color="#6666FF"
						top="0"
						width="90">
					</control-mobile-header1>
					<control-mobile-header1
						background_color="transparent"
						left="370"
						name="Частота ---"
						position="absolute"
						text_bold="1"
						text_color="#CCC"
						top="0"
						width="150">
					</control-mobile-header1>
				</control-common-rect1>
				<control-common-trend1
					autoscale1="2"
					autoscale2="2"
					autoscale3="2"
					color1="red"
					color2="green"
					color3="#6666FF"
					height="220"
					left_padding="50"
					left_scale_color="#AAAAAA"
					name1="L1L2"
					name2="L2L3"
					name3="L3L1"
					timeline="0"
					value1="$node.vars.deif_UbusL1L2.update"
					value2="$node.vars.deif_UbusL2L3.update"
					value3="$node.vars.deif_UbusL3L1.update">
				</control-common-trend1>
				<control-common-trend1
					border_color="#212631"
					border_top_width="1"
					color1="#AAAAAA"
					height="80"
					left_padding="50"
					name1="частота"
					value1="$node.vars.deif_fbus.update">
				</control-common-trend1>
			</control-common-rect1>
		</control-common-rect1>
</div>`,
  );

  Util.registerCustomElement(class widgetInterfaceMimic2 extends aNode{

    static get properties(){
      return Util.merge(super.properties,{
        value:{
          type:'string',
        },
      });
    }

    create(){
      let self=this;
      super.create();
      self.append(template);
      self.onclick=function (e){
        self.value=12345;
        console.log(self.value);
      }
    }

    update(changes){
      let self=this;
      //console.log('update',changes);
      for(let i=0; i<changes.length; i++){
        let k=changes[i];
        //console.log(k,self[k]);
      }
    }

  });

})();
