/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $caption="Параметры узла";
}else{
  var $caption="Node parameters";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<a-card id="card"></a-card>`,
);

PROPERTIES={
	path:{
		type:'string',
        propagate:false,
	},
};


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

function create(){
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}



function update_path(path){
    pult.unsubscribeStatusVar(self);
	pult.showObject(self,self.path,$caption,function (o){
        pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});
        if(o.prototype){
            pult.loadObject(self,{
                path:`${pult.getProjectPath(o._path)}/prototypes/${o.prototype}`,
                docs:'@content.json'
            },function (p){
                let content=p?.['@content.json'].data;
                let params=content?.params;

                let dics=[];

                for(let i=0; i<params?.length; i++){
                    let p=params[i];
                    if(!p.hidden && p.type==='dictionary'){
                        dics.push(p.dictionary);
                    }
                }

                loadDictionaries(dics,function (dictionaries){
                    let data={};
                    let schema=[];
                    for(let i=0; i<params?.length; i++){
                        let p=params[i];
                        if(!p.hidden){
                            let v=o['param_'+p.name];
                            if(v===undefined) v=p.default;
        
                            if(p.type==='list'){
                                v=pult.getListValue(p.list,v);
                            }else if(p.type==='dictionary'){
                                let list=dictionaries[p.dictionary];
                                v=pult.getListValue(list,v);
                            }
        
                            data[p.name]=v;
                            schema.push({
                                key:p.name,
                                caption:p.caption || p.name,
                            });
                        }
                    }
                    dom.card.schema=schema;
                    dom.card.data=data;
                });

            });
        }
    });
}


function loadDictionaries(dics,handler){
    let project=pult.getProjectName(self.path);
    let dictionaries={};
    let ff=[];
    for(let i=0; i<dics.length; i++){
        let name=dics[i];
        let f=function(resolve){
            pult.loadDictionary(self,name,project,function (list){
                dictionaries[name]=list;
                resolve();
            });
        }
        ff.push(f);
    }
    ff.push(function (){
        handler(dictionaries);
    });
    Util.promises(...ff);
}

