/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $plan="План";
  var $add="Добавить";
  var $delete="Удалить";
  var $clone="Клонировать";
  var $rename="Переименовать";
  var $settings="Настройки";
  var $do_settings="Настроить";
  var $schedule_settings="Настройки расписания";
  var $values_count="Количество задаваемых значений";
  var $value="Значение";
  var $caption="Надпись";
  var $height="Высота, %";
  var $color="Цвет";
  var $delay="Задержка: %s с";
  var $calendar="Календарь";
  var $no_vars_added="Для тестирования необходимо добавить один или несколько узлов";
  
  var $delay_comment="Запись значений в переменные будет выполняться последовательно, с указанным интервалом. Даная опция позволяет разнести во времени пусковые токи мощных реактивных нагрузок.";
  var $delay_s="Задержка, с";
  var $delay_caption="Задержка";
  
  var $apply_template="Загрузить настройки из шаблона";
  var $add_plan="Добавить план";
  var $rename_plan="Переименовать план";
  var $confirm_change_layout="Изменить раскладку?";
  var $change_layout_text="Почасовые задания текущей раскладки будут потеряны!";
  var $plan_letters="АБВГДЕЖЗИКЛМНОПРСТУФХЦЧШЩЪЫьЭЮЯ";
  var $plan_error_exists="Такой план уже есть";
  var $var="Переменная";
  var $delete="Удалить";
  var $cancel="Отменить";
  var $save="Сохранить";
  var $cancel_changes="Отменить изменения?";
  var $disabled="Отключено";
  var $enabled="Включено";
  var $clone_schedule='Клонировать расписание';
  var $rename_schedule='Переименовать расписание';
  var $delete_schedule='Удалить расписание';
  var $confirm_delete_schedule='Удалить расписание?';

  var $clone_plan="Клонировать план";
  var $delete_plan="Удалить план";
  var $confirm_delete_plan="Удалить %s?";
  var $disabled_text="Расписание отключено: задачи не выполняются";

  var $empty_vars="Узлы не добавлены";

  var $help="Почасовое расписание";
  var $help_text=`Почасовое расписание состоит из одного или нескольких планов. План содержит почасовые задания. Задания активного плана выполняются в указанные часы. При выполнении заданий задаваемое значение записывается в управляемые узлы. 
  
  <h4>План</h4> Расписание может содержать один или несколько планов, например для зимнего и летнего режимов работы оборудования. При этом, каждый план содержит свои почасовые задания. Выполняются только задания активного (выбранного) плана. Задания остальных планов игнорируются.
  
  <h4>Почасовые задания</h4> Почасовые задания выполняются каждый час, в 00 минут 00 секунд, если содержат задаваемое значение. Пустые клетки почасовых заданий (не содержащие задаваемого значения) не выполняются (в соответствующие им часы не происходит изменение управляемых переменных).

  Почасовые задания представлены в виде раскладки по дням недели или по рабочим/выходным дням. Почасовые задания, выполняемые по рабочим/выходным дням, определяют статус дня (рабочий или выходной) по календарю, который может быть настроен в разделе Система / Календарь. Почасовые задания, выполняемые по дням недели не учитывают календарь.

  <h4>Задаваемые значения</h4> Расписание содержит один набор задаваемых значений, который применяется ко всем планам. Набор значений может быть настроен и может содержать от 2 до 21 фиксированного значения. Каждое значение может быть представлено в виде, числа или соответствующей надписи на кнопке, иметь свой цвет и высоту заполнения клетки в таблице почасовых заданий.

  <h4>Управляемые узлы</h4> Расписание содержит один набор управляемых узлов, который применяется ко всем планам. При выполнении почасового задания, задаваемое значение записывается в указанную переменную управляемого узла.

  `;

  var $dw_su="Вс";
	var $dw_mo="Пн";
	var $dw_tu="Вт";
	var $dw_we="Ср";
	var $dw_th="Чт";
	var $dw_fr="Пт";
	var $dw_sa="Сб";
	var $dw_wd="РД";
	var $dw_hd="ВД";

  var $weekdays="По дням недели";
  var $holidays="По рабочим/выходным";

  var $days='Дни';
  var $hours='Часы';

  var $template_name_onoff='Шаблон "Включение/Отключение"';
  var $template_name_setpoint='Шаблон "Уставка температуры"';

  var $template_value_text_on="Вкл";
  var $template_value_text_off="Откл";

  var $setup_values="Задаваемые значения";
  var $controlled_objects="Управляемые узлы";
  var $confirm_delete_vars="Удалить выбранные узлы из расписания?"

  var $add="Добавить";
  var $delete="Удалить";
  var $show_vars="Показать переменные";

  var $test="Тест";
  
  var $test_help="При выполнении теста, в расписании будет создано единовременное проверочное задание, которое должно будет выполнится через 10 секунд и записать в управляемые переменные указанное значение.";
  var $schedule_test="Тест расписания";
  var $start="Выполнить";
  var $setup_value="Задаваемое значение";
  var $countdown="Обратный отсчет";
  var $vars="Переменные";
  var $current_values="Текущие значения";

  var $nosave_text="Расписание открыто только для просмотра. У вас нет доступа на редактирование данного расписания.";

}else{

  var $plan="Plan";
  var $add="Add";
  var $delete="Delete";
  var $clone="Clone";
  var $rename="Rename";
  var $settings="Settings";
  var $do_settings="Set up";
  var $schedule_settings="Schedule settings";
  var $values_count="Number of setup values";
  var $value="Value";
  var $caption="Caption";
  var $height="Height, %";
  var $color="Color";
  var $delay="Delay: %s s";

  var $delay_comment="Writing of values ​​to variables will be performed sequentially, with the specified interval. This option allows to spread out in time the starting currents of powerful reactive consumers.";
  var $delay_s="Delay, s";
  var $delay_caption="Delay";
  var $calendar="Calendar";
  var $no_vars_added="One or more nodes must be added for testing";
  
  
  var $apply_template="Load settings from template";
  var $add_plan="Add plan";
  var $rename_plan="Rename plan";
  var $confirm_change_layout="Change layout?";
  var $change_layout_text="Hourly tasks of the current layout will be lost!";
  var $plan_letters="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  var $plan_error_exists="Plan already exists";
  var $var="Variable";
  var $delete="Delete";
  var $cancel="Cancel";
  var $save="Save";
  var $cancel_changes="Cancel changes?";
  var $disabled="Disabled";
  var $enabled="Enabled";
  var $clone_schedule='Clone schedule';
  var $rename_schedule='Rename schedule';
  var $delete_schedule='Delete schedule';
  var $confirm_delete_schedule='Delete schedule?';

  var $clone_plan="Clone plan";
  var $delete_plan="Delete plan";
  var $confirm_delete_plan="Delete %s?";
  var $disabled_text="Schedule disabled: tasks are not running";

  var $empty_vars="No nodes added";

  var $help="Hourly schedule";
  var $help_text=`An hourly schedule consists of one or more plans. A plan contains hourly tasks. The tasks of the active plan are executed at the specified hours. When the tasks are executed, the specified value is written to the controlled nodes.

  <h4>Plan</h4> A schedule can contain one or more plans, for example, for winter and summer equipment operation modes. In this case, each plan contains its own hourly tasks. Only the tasks of the active (selected) plan are executed. Tasks of other plans are ignored.

  <h4>Hourly tasks</h4> Hourly tasks are executed every hour, at 00 minutes 00 seconds, if they contain the specified value. Empty cells of hourly tasks (not containing the specified value) are not executed (the controlled variables do not change at the corresponding hours).

  Hourly tasks are presented as a layout by days of the week or by working/weekend days. Hourly tasks executed on work/weekend days determine the day status (work or weekend) according to the calendar, which can be configured in the System / Calendar section. Hourly tasks executed on weekdays do not take the calendar into account.

  <h4>Set Values</h4> The schedule contains one set of set values, which applies to all plans. The set of values ​​can be configured and can contain from 2 to 21 fixed values. Each value can be presented as a number or a corresponding inscription on the button, have its own color and cell filling height in the hourly tasks table.

  <h4>Controlled Nodes</h4> The schedule contains one set of controlled nodes, which applies to all plans. When an hourly task is executed, the set value is written to the specified variable of the controlled node.

  `;

  var $dw_su="Su";
	var $dw_mo="Mo";
	var $dw_tu="Tu";
	var $dw_we="We";
	var $dw_th="Th";
	var $dw_fr="Fr";
	var $dw_sa="Sa";
	var $dw_wd="WD";
	var $dw_hd="HD";

  var $weekdays="By weekdays";
  var $holidays="By workdays/holidays";

  var $days='Days';
  var $hours='Hours';

  var $template_name_onoff='Template "On/Off"';
  var $template_name_setpoint='Template "Setpoint"';
  var $template_value_text_on="On";
  var $template_value_text_off="Off";

  var $setup_values="Setup values";
  var $controlled_objects="Controlled nodes";
  var $confirm_delete_vars="Delete selected nodes from schedule?"

  var $add="Add";
  var $delete="Delete";
  var $show_vars="Show vars";
  var $test="Test";

  var $test_help="When the test is executed, a one-time test task will be created in the schedule, which will have to be executed in 10 seconds and write the specified value to the controlled variables.";
  var $start="Start";
  var $setup_value="Set value";
  var $countdown="Countdown";
  var $vars="Variables";
  var $current_values="Current values";
  
  var $nosave_text="The schedule is open for viewing only. You do not have access to edit this schedule.";

}

/**
* chroma.js - JavaScript library for color conversions
*/

!function(r,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(r="undefined"!=typeof globalThis?globalThis:r||self).chroma=e()}(this,(function(){"use strict";for(var r=function(r,e,n){return void 0===e&&(e=0),void 0===n&&(n=1),r<e?e:r>n?n:r},e=r,n={},t=0,a=["Boolean","Number","String","Function","Array","Date","RegExp","Undefined","Null"];t<a.length;t+=1){var f=a[t];n["[object "+f+"]"]=f.toLowerCase()}var o=function(r){return n[Object.prototype.toString.call(r)]||"object"},u=o,c=o,i=Math.PI,l={clip_rgb:function(r){r._clipped=!1,r._unclipped=r.slice(0);for(var n=0;n<=3;n++)n<3?((r[n]<0||r[n]>255)&&(r._clipped=!0),r[n]=e(r[n],0,255)):3===n&&(r[n]=e(r[n],0,1));return r},limit:r,type:o,unpack:function(r,e){return void 0===e&&(e=null),r.length>=3?Array.prototype.slice.call(r):"object"==u(r[0])&&e?e.split("").filter((function(e){return void 0!==r[0][e]})).map((function(e){return r[0][e]})):r[0]},last:function(r){if(r.length<2)return null;var e=r.length-1;return"string"==c(r[e])?r[e].toLowerCase():null},PI:i,TWOPI:2*i,PITHIRD:i/3,DEG2RAD:i/180,RAD2DEG:180/i},h={format:{},autodetect:[]},s=l.last,d=l.clip_rgb,b=l.type,p=h,g=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=this;if("object"===b(r[0])&&r[0].constructor&&r[0].constructor===this.constructor)return r[0];var t=s(r),a=!1;if(!t){a=!0,p.sorted||(p.autodetect=p.autodetect.sort((function(r,e){return e.p-r.p})),p.sorted=!0);for(var f=0,o=p.autodetect;f<o.length;f+=1){var u=o[f];if(t=u.test.apply(u,r))break}}if(!p.format[t])throw new Error("unknown format: "+r);var c=p.format[t].apply(null,a?r:r.slice(0,-1));n._rgb=d(c),3===n._rgb.length&&n._rgb.push(1)};g.prototype.toString=function(){return"function"==b(this.hex)?this.hex():"["+this._rgb.join(",")+"]"};var v=g,m=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(m.Color,[null].concat(r)))};m.Color=v,m.version="2.4.2";var y=m,k=l.unpack,w=Math.max,M=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=k(r,"rgb"),t=n[0],a=n[1],f=n[2],o=1-w(t/=255,w(a/=255,f/=255)),u=o<1?1/(1-o):0,c=(1-t-o)*u,i=(1-a-o)*u,l=(1-f-o)*u;return[c,i,l,o]},N=l.unpack,_=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=(r=N(r,"cmyk"))[0],t=r[1],a=r[2],f=r[3],o=r.length>4?r[4]:1;return 1===f?[0,0,0,o]:[n>=1?0:255*(1-n)*(1-f),t>=1?0:255*(1-t)*(1-f),a>=1?0:255*(1-a)*(1-f),o]},x=y,A=v,E=h,F=l.unpack,P=l.type,O=M;A.prototype.cmyk=function(){return O(this._rgb)},x.cmyk=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(A,[null].concat(r,["cmyk"])))},E.format.cmyk=_,E.autodetect.push({p:2,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=F(r,"cmyk"),"array"===P(r)&&4===r.length)return"cmyk"}});var j=l.unpack,G=l.last,R=function(r){return Math.round(100*r)/100},q=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=j(r,"hsla"),t=G(r)||"lsa";return n[0]=R(n[0]||0),n[1]=R(100*n[1])+"%",n[2]=R(100*n[2])+"%","hsla"===t||n.length>3&&n[3]<1?(n[3]=n.length>3?n[3]:1,t="hsla"):n.length=3,t+"("+n.join(",")+")"},L=l.unpack,I=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=(r=L(r,"rgba"))[0],t=r[1],a=r[2];n/=255,t/=255,a/=255;var f,o,u=Math.min(n,t,a),c=Math.max(n,t,a),i=(c+u)/2;return c===u?(f=0,o=Number.NaN):f=i<.5?(c-u)/(c+u):(c-u)/(2-c-u),n==c?o=(t-a)/(c-u):t==c?o=2+(a-n)/(c-u):a==c&&(o=4+(n-t)/(c-u)),(o*=60)<0&&(o+=360),r.length>3&&void 0!==r[3]?[o,f,i,r[3]]:[o,f,i]},B=l.unpack,C=l.last,D=q,Y=I,S=Math.round,T=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=B(r,"rgba"),t=C(r)||"rgb";return"hsl"==t.substr(0,3)?D(Y(n),t):(n[0]=S(n[0]),n[1]=S(n[1]),n[2]=S(n[2]),("rgba"===t||n.length>3&&n[3]<1)&&(n[3]=n.length>3?n[3]:1,t="rgba"),t+"("+n.slice(0,"rgb"===t?3:4).join(",")+")")},$=l.unpack,z=Math.round,X=function(){for(var r,e=[],n=arguments.length;n--;)e[n]=arguments[n];var t,a,f,o=(e=$(e,"hsl"))[0],u=e[1],c=e[2];if(0===u)t=a=f=255*c;else{var i=[0,0,0],l=[0,0,0],h=c<.5?c*(1+u):c+u-c*u,s=2*c-h,d=o/360;i[0]=d+1/3,i[1]=d,i[2]=d-1/3;for(var b=0;b<3;b++)i[b]<0&&(i[b]+=1),i[b]>1&&(i[b]-=1),6*i[b]<1?l[b]=s+6*(h-s)*i[b]:2*i[b]<1?l[b]=h:3*i[b]<2?l[b]=s+(h-s)*(2/3-i[b])*6:l[b]=s;t=(r=[z(255*l[0]),z(255*l[1]),z(255*l[2])])[0],a=r[1],f=r[2]}return e.length>3?[t,a,f,e[3]]:[t,a,f,1]},U=X,V=h,W=/^rgb\(\s*(-?\d+),\s*(-?\d+)\s*,\s*(-?\d+)\s*\)$/,K=/^rgba\(\s*(-?\d+),\s*(-?\d+)\s*,\s*(-?\d+)\s*,\s*([01]|[01]?\.\d+)\)$/,Z=/^rgb\(\s*(-?\d+(?:\.\d+)?)%,\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*\)$/,H=/^rgba\(\s*(-?\d+(?:\.\d+)?)%,\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)$/,J=/^hsl\(\s*(-?\d+(?:\.\d+)?),\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*\)$/,Q=/^hsla\(\s*(-?\d+(?:\.\d+)?),\s*(-?\d+(?:\.\d+)?)%\s*,\s*(-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)$/,rr=Math.round,er=function(r){var e;if(r=r.toLowerCase().trim(),V.format.named)try{return V.format.named(r)}catch(r){}if(e=r.match(W)){for(var n=e.slice(1,4),t=0;t<3;t++)n[t]=+n[t];return n[3]=1,n}if(e=r.match(K)){for(var a=e.slice(1,5),f=0;f<4;f++)a[f]=+a[f];return a}if(e=r.match(Z)){for(var o=e.slice(1,4),u=0;u<3;u++)o[u]=rr(2.55*o[u]);return o[3]=1,o}if(e=r.match(H)){for(var c=e.slice(1,5),i=0;i<3;i++)c[i]=rr(2.55*c[i]);return c[3]=+c[3],c}if(e=r.match(J)){var l=e.slice(1,4);l[1]*=.01,l[2]*=.01;var h=U(l);return h[3]=1,h}if(e=r.match(Q)){var s=e.slice(1,4);s[1]*=.01,s[2]*=.01;var d=U(s);return d[3]=+e[4],d}};er.test=function(r){return W.test(r)||K.test(r)||Z.test(r)||H.test(r)||J.test(r)||Q.test(r)};var nr=y,tr=v,ar=h,fr=l.type,or=T,ur=er;tr.prototype.css=function(r){return or(this._rgb,r)},nr.css=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(tr,[null].concat(r,["css"])))},ar.format.css=ur,ar.autodetect.push({p:5,test:function(r){for(var e=[],n=arguments.length-1;n-- >0;)e[n]=arguments[n+1];if(!e.length&&"string"===fr(r)&&ur.test(r))return"css"}});var cr=v,ir=y,lr=l.unpack;h.format.gl=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=lr(r,"rgba");return n[0]*=255,n[1]*=255,n[2]*=255,n},ir.gl=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(cr,[null].concat(r,["gl"])))},cr.prototype.gl=function(){var r=this._rgb;return[r[0]/255,r[1]/255,r[2]/255,r[3]]};var hr=l.unpack,sr=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n,t=hr(r,"rgb"),a=t[0],f=t[1],o=t[2],u=Math.min(a,f,o),c=Math.max(a,f,o),i=c-u,l=100*i/255,h=u/(255-i)*100;return 0===i?n=Number.NaN:(a===c&&(n=(f-o)/i),f===c&&(n=2+(o-a)/i),o===c&&(n=4+(a-f)/i),(n*=60)<0&&(n+=360)),[n,l,h]},dr=l.unpack,br=Math.floor,pr=function(){for(var r,e,n,t,a,f,o=[],u=arguments.length;u--;)o[u]=arguments[u];var c,i,l,h=(o=dr(o,"hcg"))[0],s=o[1],d=o[2];d*=255;var b=255*s;if(0===s)c=i=l=d;else{360===h&&(h=0),h>360&&(h-=360),h<0&&(h+=360);var p=br(h/=60),g=h-p,v=d*(1-s),m=v+b*(1-g),y=v+b*g,k=v+b;switch(p){case 0:c=(r=[k,y,v])[0],i=r[1],l=r[2];break;case 1:c=(e=[m,k,v])[0],i=e[1],l=e[2];break;case 2:c=(n=[v,k,y])[0],i=n[1],l=n[2];break;case 3:c=(t=[v,m,k])[0],i=t[1],l=t[2];break;case 4:c=(a=[y,v,k])[0],i=a[1],l=a[2];break;case 5:c=(f=[k,v,m])[0],i=f[1],l=f[2]}}return[c,i,l,o.length>3?o[3]:1]},gr=l.unpack,vr=l.type,mr=y,yr=v,kr=h,wr=sr;yr.prototype.hcg=function(){return wr(this._rgb)},mr.hcg=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(yr,[null].concat(r,["hcg"])))},kr.format.hcg=pr,kr.autodetect.push({p:1,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=gr(r,"hcg"),"array"===vr(r)&&3===r.length)return"hcg"}});var Mr=l.unpack,Nr=l.last,_r=Math.round,xr=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=Mr(r,"rgba"),t=n[0],a=n[1],f=n[2],o=n[3],u=Nr(r)||"auto";void 0===o&&(o=1),"auto"===u&&(u=o<1?"rgba":"rgb");var c=(t=_r(t))<<16|(a=_r(a))<<8|(f=_r(f)),i="000000"+c.toString(16);i=i.substr(i.length-6);var l="0"+_r(255*o).toString(16);switch(l=l.substr(l.length-2),u.toLowerCase()){case"rgba":return"#"+i+l;case"argb":return"#"+l+i;default:return"#"+i}},Ar=/^#?([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/,Er=/^#?([A-Fa-f0-9]{8}|[A-Fa-f0-9]{4})$/,Fr=function(r){if(r.match(Ar)){4!==r.length&&7!==r.length||(r=r.substr(1)),3===r.length&&(r=(r=r.split(""))[0]+r[0]+r[1]+r[1]+r[2]+r[2]);var e=parseInt(r,16);return[e>>16,e>>8&255,255&e,1]}if(r.match(Er)){5!==r.length&&9!==r.length||(r=r.substr(1)),4===r.length&&(r=(r=r.split(""))[0]+r[0]+r[1]+r[1]+r[2]+r[2]+r[3]+r[3]);var n=parseInt(r,16);return[n>>24&255,n>>16&255,n>>8&255,Math.round((255&n)/255*100)/100]}throw new Error("unknown hex color: "+r)},Pr=y,Or=v,jr=l.type,Gr=h,Rr=xr;Or.prototype.hex=function(r){return Rr(this._rgb,r)},Pr.hex=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(Or,[null].concat(r,["hex"])))},Gr.format.hex=Fr,Gr.autodetect.push({p:4,test:function(r){for(var e=[],n=arguments.length-1;n-- >0;)e[n]=arguments[n+1];if(!e.length&&"string"===jr(r)&&[3,4,5,6,7,8,9].indexOf(r.length)>=0)return"hex"}});var qr=l.unpack,Lr=l.TWOPI,Ir=Math.min,Br=Math.sqrt,Cr=Math.acos,Dr=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n,t=qr(r,"rgb"),a=t[0],f=t[1],o=t[2],u=Ir(a/=255,f/=255,o/=255),c=(a+f+o)/3,i=c>0?1-u/c:0;return 0===i?n=NaN:(n=(a-f+(a-o))/2,n/=Br((a-f)*(a-f)+(a-o)*(f-o)),n=Cr(n),o>f&&(n=Lr-n),n/=Lr),[360*n,i,c]},Yr=l.unpack,Sr=l.limit,Tr=l.TWOPI,$r=l.PITHIRD,zr=Math.cos,Xr=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n,t,a,f=(r=Yr(r,"hsi"))[0],o=r[1],u=r[2];return isNaN(f)&&(f=0),isNaN(o)&&(o=0),f>360&&(f-=360),f<0&&(f+=360),(f/=360)<1/3?t=1-((a=(1-o)/3)+(n=(1+o*zr(Tr*f)/zr($r-Tr*f))/3)):f<2/3?a=1-((n=(1-o)/3)+(t=(1+o*zr(Tr*(f-=1/3))/zr($r-Tr*f))/3)):n=1-((t=(1-o)/3)+(a=(1+o*zr(Tr*(f-=2/3))/zr($r-Tr*f))/3)),[255*(n=Sr(u*n*3)),255*(t=Sr(u*t*3)),255*(a=Sr(u*a*3)),r.length>3?r[3]:1]},Ur=l.unpack,Vr=l.type,Wr=y,Kr=v,Zr=h,Hr=Dr;Kr.prototype.hsi=function(){return Hr(this._rgb)},Wr.hsi=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(Kr,[null].concat(r,["hsi"])))},Zr.format.hsi=Xr,Zr.autodetect.push({p:2,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=Ur(r,"hsi"),"array"===Vr(r)&&3===r.length)return"hsi"}});var Jr=l.unpack,Qr=l.type,re=y,ee=v,ne=h,te=I;ee.prototype.hsl=function(){return te(this._rgb)},re.hsl=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(ee,[null].concat(r,["hsl"])))},ne.format.hsl=X,ne.autodetect.push({p:2,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=Jr(r,"hsl"),"array"===Qr(r)&&3===r.length)return"hsl"}});var ae=l.unpack,fe=Math.min,oe=Math.max,ue=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n,t,a,f=(r=ae(r,"rgb"))[0],o=r[1],u=r[2],c=fe(f,o,u),i=oe(f,o,u),l=i-c;return a=i/255,0===i?(n=Number.NaN,t=0):(t=l/i,f===i&&(n=(o-u)/l),o===i&&(n=2+(u-f)/l),u===i&&(n=4+(f-o)/l),(n*=60)<0&&(n+=360)),[n,t,a]},ce=l.unpack,ie=Math.floor,le=function(){for(var r,e,n,t,a,f,o=[],u=arguments.length;u--;)o[u]=arguments[u];var c,i,l,h=(o=ce(o,"hsv"))[0],s=o[1],d=o[2];if(d*=255,0===s)c=i=l=d;else{360===h&&(h=0),h>360&&(h-=360),h<0&&(h+=360);var b=ie(h/=60),p=h-b,g=d*(1-s),v=d*(1-s*p),m=d*(1-s*(1-p));switch(b){case 0:c=(r=[d,m,g])[0],i=r[1],l=r[2];break;case 1:c=(e=[v,d,g])[0],i=e[1],l=e[2];break;case 2:c=(n=[g,d,m])[0],i=n[1],l=n[2];break;case 3:c=(t=[g,v,d])[0],i=t[1],l=t[2];break;case 4:c=(a=[m,g,d])[0],i=a[1],l=a[2];break;case 5:c=(f=[d,g,v])[0],i=f[1],l=f[2]}}return[c,i,l,o.length>3?o[3]:1]},he=l.unpack,se=l.type,de=y,be=v,pe=h,ge=ue;be.prototype.hsv=function(){return ge(this._rgb)},de.hsv=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(be,[null].concat(r,["hsv"])))},pe.format.hsv=le,pe.autodetect.push({p:2,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=he(r,"hsv"),"array"===se(r)&&3===r.length)return"hsv"}});var ve={Kn:18,Xn:.95047,Yn:1,Zn:1.08883,t0:.137931034,t1:.206896552,t2:.12841855,t3:.008856452},me=ve,ye=l.unpack,ke=Math.pow,we=function(r){return(r/=255)<=.04045?r/12.92:ke((r+.055)/1.055,2.4)},Me=function(r){return r>me.t3?ke(r,1/3):r/me.t2+me.t0},Ne=function(r,e,n){return r=we(r),e=we(e),n=we(n),[Me((.4124564*r+.3575761*e+.1804375*n)/me.Xn),Me((.2126729*r+.7151522*e+.072175*n)/me.Yn),Me((.0193339*r+.119192*e+.9503041*n)/me.Zn)]},_e=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=ye(r,"rgb"),t=n[0],a=n[1],f=n[2],o=Ne(t,a,f),u=o[0],c=o[1],i=o[2],l=116*c-16;return[l<0?0:l,500*(u-c),200*(c-i)]},xe=ve,Ae=l.unpack,Ee=Math.pow,Fe=function(r){return 255*(r<=.00304?12.92*r:1.055*Ee(r,1/2.4)-.055)},Pe=function(r){return r>xe.t1?r*r*r:xe.t2*(r-xe.t0)},Oe=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n,t,a,f=(r=Ae(r,"lab"))[0],o=r[1],u=r[2];return t=(f+16)/116,n=isNaN(o)?t:t+o/500,a=isNaN(u)?t:t-u/200,t=xe.Yn*Pe(t),n=xe.Xn*Pe(n),a=xe.Zn*Pe(a),[Fe(3.2404542*n-1.5371385*t-.4985314*a),Fe(-.969266*n+1.8760108*t+.041556*a),Fe(.0556434*n-.2040259*t+1.0572252*a),r.length>3?r[3]:1]},je=l.unpack,Ge=l.type,Re=y,qe=v,Le=h,Ie=_e;qe.prototype.lab=function(){return Ie(this._rgb)},Re.lab=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(qe,[null].concat(r,["lab"])))},Le.format.lab=Oe,Le.autodetect.push({p:2,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=je(r,"lab"),"array"===Ge(r)&&3===r.length)return"lab"}});var Be=l.unpack,Ce=l.RAD2DEG,De=Math.sqrt,Ye=Math.atan2,Se=Math.round,Te=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=Be(r,"lab"),t=n[0],a=n[1],f=n[2],o=De(a*a+f*f),u=(Ye(f,a)*Ce+360)%360;return 0===Se(1e4*o)&&(u=Number.NaN),[t,o,u]},$e=l.unpack,ze=_e,Xe=Te,Ue=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=$e(r,"rgb"),t=n[0],a=n[1],f=n[2],o=ze(t,a,f),u=o[0],c=o[1],i=o[2];return Xe(u,c,i)},Ve=l.unpack,We=l.DEG2RAD,Ke=Math.sin,Ze=Math.cos,He=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=Ve(r,"lch"),t=n[0],a=n[1],f=n[2];return isNaN(f)&&(f=0),[t,Ze(f*=We)*a,Ke(f)*a]},Je=l.unpack,Qe=He,rn=Oe,en=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=(r=Je(r,"lch"))[0],t=r[1],a=r[2],f=Qe(n,t,a),o=f[0],u=f[1],c=f[2],i=rn(o,u,c),l=i[0],h=i[1],s=i[2];return[l,h,s,r.length>3?r[3]:1]},nn=l.unpack,tn=en,an=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=nn(r,"hcl").reverse();return tn.apply(void 0,n)},fn=l.unpack,on=l.type,un=y,cn=v,ln=h,hn=Ue;cn.prototype.lch=function(){return hn(this._rgb)},cn.prototype.hcl=function(){return hn(this._rgb).reverse()},un.lch=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(cn,[null].concat(r,["lch"])))},un.hcl=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(cn,[null].concat(r,["hcl"])))},ln.format.lch=en,ln.format.hcl=an,["lch","hcl"].forEach((function(r){return ln.autodetect.push({p:2,test:function(){for(var e=[],n=arguments.length;n--;)e[n]=arguments[n];if(e=fn(e,r),"array"===on(e)&&3===e.length)return r}})}));var sn={aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflower:"#6495ed",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgreen:"#006400",darkgrey:"#a9a9a9",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",green:"#008000",greenyellow:"#adff2f",grey:"#808080",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",laserlemon:"#ffff54",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrod:"#fafad2",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgreen:"#90ee90",lightgrey:"#d3d3d3",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",maroon2:"#7f0000",maroon3:"#b03060",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370db",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#db7093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",purple2:"#7f007f",purple3:"#a020f0",rebeccapurple:"#663399",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},dn=h,bn=l.type,pn=sn,gn=Fr,vn=xr;v.prototype.name=function(){for(var r=vn(this._rgb,"rgb"),e=0,n=Object.keys(pn);e<n.length;e+=1){var t=n[e];if(pn[t]===r)return t.toLowerCase()}return r},dn.format.named=function(r){if(r=r.toLowerCase(),pn[r])return gn(pn[r]);throw new Error("unknown color name: "+r)},dn.autodetect.push({p:5,test:function(r){for(var e=[],n=arguments.length-1;n-- >0;)e[n]=arguments[n+1];if(!e.length&&"string"===bn(r)&&pn[r.toLowerCase()])return"named"}});var mn=l.unpack,yn=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=mn(r,"rgb"),t=n[0],a=n[1],f=n[2];return(t<<16)+(a<<8)+f},kn=l.type,wn=function(r){if("number"==kn(r)&&r>=0&&r<=16777215)return[r>>16,r>>8&255,255&r,1];throw new Error("unknown num color: "+r)},Mn=y,Nn=v,_n=h,xn=l.type,An=yn;Nn.prototype.num=function(){return An(this._rgb)},Mn.num=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(Nn,[null].concat(r,["num"])))},_n.format.num=wn,_n.autodetect.push({p:5,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(1===r.length&&"number"===xn(r[0])&&r[0]>=0&&r[0]<=16777215)return"num"}});var En=y,Fn=v,Pn=h,On=l.unpack,jn=l.type,Gn=Math.round;Fn.prototype.rgb=function(r){return void 0===r&&(r=!0),!1===r?this._rgb.slice(0,3):this._rgb.slice(0,3).map(Gn)},Fn.prototype.rgba=function(r){return void 0===r&&(r=!0),this._rgb.slice(0,4).map((function(e,n){return n<3?!1===r?e:Gn(e):e}))},En.rgb=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(Fn,[null].concat(r,["rgb"])))},Pn.format.rgb=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=On(r,"rgba");return void 0===n[3]&&(n[3]=1),n},Pn.autodetect.push({p:3,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=On(r,"rgba"),"array"===jn(r)&&(3===r.length||4===r.length&&"number"==jn(r[3])&&r[3]>=0&&r[3]<=1))return"rgb"}});var Rn=Math.log,qn=function(r){var e,n,t,a=r/100;return a<66?(e=255,n=a<6?0:-155.25485562709179-.44596950469579133*(n=a-2)+104.49216199393888*Rn(n),t=a<20?0:.8274096064007395*(t=a-10)-254.76935184120902+115.67994401066147*Rn(t)):(e=351.97690566805693+.114206453784165*(e=a-55)-40.25366309332127*Rn(e),n=325.4494125711974+.07943456536662342*(n=a-50)-28.0852963507957*Rn(n),t=255),[e,n,t,1]},Ln=qn,In=l.unpack,Bn=Math.round,Cn=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];for(var n,t=In(r,"rgb"),a=t[0],f=t[2],o=1e3,u=4e4,c=.4;u-o>c;){var i=Ln(n=.5*(u+o));i[2]/i[0]>=f/a?u=n:o=n}return Bn(n)},Dn=y,Yn=v,Sn=h,Tn=Cn;Yn.prototype.temp=Yn.prototype.kelvin=Yn.prototype.temperature=function(){return Tn(this._rgb)},Dn.temp=Dn.kelvin=Dn.temperature=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(Yn,[null].concat(r,["temp"])))},Sn.format.temp=Sn.format.kelvin=Sn.format.temperature=qn;var $n=l.unpack,zn=Math.cbrt,Xn=Math.pow,Un=Math.sign,Vn=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=$n(r,"rgb"),t=n[0],a=n[1],f=n[2],o=[Wn(t/255),Wn(a/255),Wn(f/255)],u=o[0],c=o[1],i=o[2],l=zn(.4122214708*u+.5363325363*c+.0514459929*i),h=zn(.2119034982*u+.6806995451*c+.1073969566*i),s=zn(.0883024619*u+.2817188376*c+.6299787005*i);return[.2104542553*l+.793617785*h-.0040720468*s,1.9779984951*l-2.428592205*h+.4505937099*s,.0259040371*l+.7827717662*h-.808675766*s]};function Wn(r){var e=Math.abs(r);return e<.04045?r/12.92:(Un(r)||1)*Xn((e+.055)/1.055,2.4)}var Kn=l.unpack,Zn=Math.pow,Hn=Math.sign,Jn=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=(r=Kn(r,"lab"))[0],t=r[1],a=r[2],f=Zn(n+.3963377774*t+.2158037573*a,3),o=Zn(n-.1055613458*t-.0638541728*a,3),u=Zn(n-.0894841775*t-1.291485548*a,3);return[255*Qn(4.0767416621*f-3.3077115913*o+.2309699292*u),255*Qn(-1.2684380046*f+2.6097574011*o-.3413193965*u),255*Qn(-.0041960863*f-.7034186147*o+1.707614701*u),r.length>3?r[3]:1]};function Qn(r){var e=Math.abs(r);return e>.0031308?(Hn(r)||1)*(1.055*Zn(e,1/2.4)-.055):12.92*r}var rt=l.unpack,et=l.type,nt=y,tt=v,at=h,ft=Vn;tt.prototype.oklab=function(){return ft(this._rgb)},nt.oklab=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(tt,[null].concat(r,["oklab"])))},at.format.oklab=Jn,at.autodetect.push({p:3,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=rt(r,"oklab"),"array"===et(r)&&3===r.length)return"oklab"}});var ot=l.unpack,ut=Vn,ct=Te,it=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=ot(r,"rgb"),t=n[0],a=n[1],f=n[2],o=ut(t,a,f),u=o[0],c=o[1],i=o[2];return ct(u,c,i)},lt=l.unpack,ht=He,st=Jn,dt=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];var n=(r=lt(r,"lch"))[0],t=r[1],a=r[2],f=ht(n,t,a),o=f[0],u=f[1],c=f[2],i=st(o,u,c),l=i[0],h=i[1],s=i[2];return[l,h,s,r.length>3?r[3]:1]},bt=l.unpack,pt=l.type,gt=y,vt=v,mt=h,yt=it;vt.prototype.oklch=function(){return yt(this._rgb)},gt.oklch=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];return new(Function.prototype.bind.apply(vt,[null].concat(r,["oklch"])))},mt.format.oklch=dt,mt.autodetect.push({p:3,test:function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];if(r=bt(r,"oklch"),"array"===pt(r)&&3===r.length)return"oklch"}});var kt=v,wt=l.type;kt.prototype.alpha=function(r,e){return void 0===e&&(e=!1),void 0!==r&&"number"===wt(r)?e?(this._rgb[3]=r,this):new kt([this._rgb[0],this._rgb[1],this._rgb[2],r],"rgb"):this._rgb[3]},v.prototype.clipped=function(){return this._rgb._clipped||!1};var Mt=v,Nt=ve;Mt.prototype.darken=function(r){void 0===r&&(r=1);var e=this.lab();return e[0]-=Nt.Kn*r,new Mt(e,"lab").alpha(this.alpha(),!0)},Mt.prototype.brighten=function(r){return void 0===r&&(r=1),this.darken(-r)},Mt.prototype.darker=Mt.prototype.darken,Mt.prototype.brighter=Mt.prototype.brighten,v.prototype.get=function(r){var e=r.split("."),n=e[0],t=e[1],a=this[n]();if(t){var f=n.indexOf(t)-("ok"===n.substr(0,2)?2:0);if(f>-1)return a[f];throw new Error("unknown channel "+t+" in mode "+n)}return a};var _t=v,xt=l.type,At=Math.pow;_t.prototype.luminance=function(r){if(void 0!==r&&"number"===xt(r)){if(0===r)return new _t([0,0,0,this._rgb[3]],"rgb");if(1===r)return new _t([255,255,255,this._rgb[3]],"rgb");var e=this.luminance(),n=20,t=function(e,a){var f=e.interpolate(a,.5,"rgb"),o=f.luminance();return Math.abs(r-o)<1e-7||!n--?f:o>r?t(e,f):t(f,a)},a=(e>r?t(new _t([0,0,0]),this):t(this,new _t([255,255,255]))).rgb();return new _t(a.concat([this._rgb[3]]))}return Et.apply(void 0,this._rgb.slice(0,3))};var Et=function(r,e,n){return.2126*(r=Ft(r))+.7152*(e=Ft(e))+.0722*(n=Ft(n))},Ft=function(r){return(r/=255)<=.03928?r/12.92:At((r+.055)/1.055,2.4)},Pt={},Ot=v,jt=l.type,Gt=Pt,Rt=function(r,e,n){void 0===n&&(n=.5);for(var t=[],a=arguments.length-3;a-- >0;)t[a]=arguments[a+3];var f=t[0]||"lrgb";if(Gt[f]||t.length||(f=Object.keys(Gt)[0]),!Gt[f])throw new Error("interpolation mode "+f+" is not defined");return"object"!==jt(r)&&(r=new Ot(r)),"object"!==jt(e)&&(e=new Ot(e)),Gt[f](r,e,n).alpha(r.alpha()+n*(e.alpha()-r.alpha()))},qt=v,Lt=Rt;qt.prototype.mix=qt.prototype.interpolate=function(r,e){void 0===e&&(e=.5);for(var n=[],t=arguments.length-2;t-- >0;)n[t]=arguments[t+2];return Lt.apply(void 0,[this,r,e].concat(n))};var It=v;It.prototype.premultiply=function(r){void 0===r&&(r=!1);var e=this._rgb,n=e[3];return r?(this._rgb=[e[0]*n,e[1]*n,e[2]*n,n],this):new It([e[0]*n,e[1]*n,e[2]*n,n],"rgb")};var Bt=v,Ct=ve;Bt.prototype.saturate=function(r){void 0===r&&(r=1);var e=this.lch();return e[1]+=Ct.Kn*r,e[1]<0&&(e[1]=0),new Bt(e,"lch").alpha(this.alpha(),!0)},Bt.prototype.desaturate=function(r){return void 0===r&&(r=1),this.saturate(-r)};var Dt=v,Yt=l.type;Dt.prototype.set=function(r,e,n){void 0===n&&(n=!1);var t=r.split("."),a=t[0],f=t[1],o=this[a]();if(f){var u=a.indexOf(f)-("ok"===a.substr(0,2)?2:0);if(u>-1){if("string"==Yt(e))switch(e.charAt(0)){case"+":case"-":o[u]+=+e;break;case"*":o[u]*=+e.substr(1);break;case"/":o[u]/=+e.substr(1);break;default:o[u]=+e}else{if("number"!==Yt(e))throw new Error("unsupported value for Color.set");o[u]=e}var c=new Dt(o,a);return n?(this._rgb=c._rgb,this):c}throw new Error("unknown channel "+f+" in mode "+a)}return o};var St=v;Pt.rgb=function(r,e,n){var t=r._rgb,a=e._rgb;return new St(t[0]+n*(a[0]-t[0]),t[1]+n*(a[1]-t[1]),t[2]+n*(a[2]-t[2]),"rgb")};var Tt=v,$t=Math.sqrt,zt=Math.pow;Pt.lrgb=function(r,e,n){var t=r._rgb,a=t[0],f=t[1],o=t[2],u=e._rgb,c=u[0],i=u[1],l=u[2];return new Tt($t(zt(a,2)*(1-n)+zt(c,2)*n),$t(zt(f,2)*(1-n)+zt(i,2)*n),$t(zt(o,2)*(1-n)+zt(l,2)*n),"rgb")};var Xt=v;Pt.lab=function(r,e,n){var t=r.lab(),a=e.lab();return new Xt(t[0]+n*(a[0]-t[0]),t[1]+n*(a[1]-t[1]),t[2]+n*(a[2]-t[2]),"lab")};var Ut=v,Vt=function(r,e,n,t){var a,f,o,u,c,i,l,h,s,d,b,p,g;return"hsl"===t?(o=r.hsl(),u=e.hsl()):"hsv"===t?(o=r.hsv(),u=e.hsv()):"hcg"===t?(o=r.hcg(),u=e.hcg()):"hsi"===t?(o=r.hsi(),u=e.hsi()):"lch"===t||"hcl"===t?(t="hcl",o=r.hcl(),u=e.hcl()):"oklch"===t&&(o=r.oklch().reverse(),u=e.oklch().reverse()),"h"!==t.substr(0,1)&&"oklch"!==t||(c=(a=o)[0],l=a[1],s=a[2],i=(f=u)[0],h=f[1],d=f[2]),isNaN(c)||isNaN(i)?isNaN(c)?isNaN(i)?p=Number.NaN:(p=i,1!=s&&0!=s||"hsv"==t||(b=h)):(p=c,1!=d&&0!=d||"hsv"==t||(b=l)):p=c+n*(i>c&&i-c>180?i-(c+360):i<c&&c-i>180?i+360-c:i-c),void 0===b&&(b=l+n*(h-l)),g=s+n*(d-s),new Ut("oklch"===t?[g,b,p]:[p,b,g],t)},Wt=Vt,Kt=function(r,e,n){return Wt(r,e,n,"lch")};Pt.lch=Kt,Pt.hcl=Kt;var Zt=v;Pt.num=function(r,e,n){var t=r.num(),a=e.num();return new Zt(t+n*(a-t),"num")};var Ht=Vt;Pt.hcg=function(r,e,n){return Ht(r,e,n,"hcg")};var Jt=Vt;Pt.hsi=function(r,e,n){return Jt(r,e,n,"hsi")};var Qt=Vt;Pt.hsl=function(r,e,n){return Qt(r,e,n,"hsl")};var ra=Vt;Pt.hsv=function(r,e,n){return ra(r,e,n,"hsv")};var ea=v;Pt.oklab=function(r,e,n){var t=r.oklab(),a=e.oklab();return new ea(t[0]+n*(a[0]-t[0]),t[1]+n*(a[1]-t[1]),t[2]+n*(a[2]-t[2]),"oklab")};var na=Vt;Pt.oklch=function(r,e,n){return na(r,e,n,"oklch")};var ta=v,aa=l.clip_rgb,fa=Math.pow,oa=Math.sqrt,ua=Math.PI,ca=Math.cos,ia=Math.sin,la=Math.atan2,ha=function(r,e){for(var n=r.length,t=[0,0,0,0],a=0;a<r.length;a++){var f=r[a],o=e[a]/n,u=f._rgb;t[0]+=fa(u[0],2)*o,t[1]+=fa(u[1],2)*o,t[2]+=fa(u[2],2)*o,t[3]+=u[3]*o}return t[0]=oa(t[0]),t[1]=oa(t[1]),t[2]=oa(t[2]),t[3]>.9999999&&(t[3]=1),new ta(aa(t))},sa=y,da=l.type,ba=Math.pow,pa=function(r){var e="rgb",n=sa("#ccc"),t=0,a=[0,1],f=[],o=[0,0],u=!1,c=[],i=!1,l=0,h=1,s=!1,d={},b=!0,p=1,g=function(r){if((r=r||["#fff","#000"])&&"string"===da(r)&&sa.brewer&&sa.brewer[r.toLowerCase()]&&(r=sa.brewer[r.toLowerCase()]),"array"===da(r)){1===r.length&&(r=[r[0],r[0]]),r=r.slice(0);for(var e=0;e<r.length;e++)r[e]=sa(r[e]);f.length=0;for(var n=0;n<r.length;n++)f.push(n/(r.length-1))}return k(),c=r},v=function(r){return r},m=function(r){return r},y=function(r,t){var a,i;if(null==t&&(t=!1),isNaN(r)||null===r)return n;if(t)i=r;else if(u&&u.length>2){var s=function(r){if(null!=u){for(var e=u.length-1,n=0;n<e&&r>=u[n];)n++;return n-1}return 0}(r);i=s/(u.length-2)}else i=h!==l?(r-l)/(h-l):1;i=m(i),t||(i=v(i)),1!==p&&(i=ba(i,p)),i=o[0]+i*(1-o[0]-o[1]),i=Math.min(1,Math.max(0,i));var g=Math.floor(1e4*i);if(b&&d[g])a=d[g];else{if("array"===da(c))for(var y=0;y<f.length;y++){var k=f[y];if(i<=k){a=c[y];break}if(i>=k&&y===f.length-1){a=c[y];break}if(i>k&&i<f[y+1]){i=(i-k)/(f[y+1]-k),a=sa.interpolate(c[y],c[y+1],i,e);break}}else"function"===da(c)&&(a=c(i));b&&(d[g]=a)}return a},k=function(){return d={}};g(r);var w=function(r){var e=sa(y(r));return i&&e[i]?e[i]():e};return w.classes=function(r){if(null!=r){if("array"===da(r))u=r,a=[r[0],r[r.length-1]];else{var e=sa.analyze(a);u=0===r?[e.min,e.max]:sa.limits(e,"e",r)}return w}return u},w.domain=function(r){if(!arguments.length)return a;l=r[0],h=r[r.length-1],f=[];var e=c.length;if(r.length===e&&l!==h)for(var n=0,t=Array.from(r);n<t.length;n+=1){var o=t[n];f.push((o-l)/(h-l))}else{for(var u=0;u<e;u++)f.push(u/(e-1));if(r.length>2){var i=r.map((function(e,n){return n/(r.length-1)})),s=r.map((function(r){return(r-l)/(h-l)}));s.every((function(r,e){return i[e]===r}))||(m=function(r){if(r<=0||r>=1)return r;for(var e=0;r>=s[e+1];)e++;var n=(r-s[e])/(s[e+1]-s[e]);return i[e]+n*(i[e+1]-i[e])})}}return a=[l,h],w},w.mode=function(r){return arguments.length?(e=r,k(),w):e},w.range=function(r,e){return g(r),w},w.out=function(r){return i=r,w},w.spread=function(r){return arguments.length?(t=r,w):t},w.correctLightness=function(r){return null==r&&(r=!0),s=r,k(),v=s?function(r){for(var e=y(0,!0).lab()[0],n=y(1,!0).lab()[0],t=e>n,a=y(r,!0).lab()[0],f=e+(n-e)*r,o=a-f,u=0,c=1,i=20;Math.abs(o)>.01&&i-- >0;)t&&(o*=-1),o<0?(u=r,r+=.5*(c-r)):(c=r,r+=.5*(u-r)),a=y(r,!0).lab()[0],o=a-f;return r}:function(r){return r},w},w.padding=function(r){return null!=r?("number"===da(r)&&(r=[r,r]),o=r,w):o},w.colors=function(e,n){arguments.length<2&&(n="hex");var t=[];if(0===arguments.length)t=c.slice(0);else if(1===e)t=[w(.5)];else if(e>1){var f=a[0],o=a[1]-f;t=ga(0,e,!1).map((function(r){return w(f+r/(e-1)*o)}))}else{r=[];var i=[];if(u&&u.length>2)for(var l=1,h=u.length,s=1<=h;s?l<h:l>h;s?l++:l--)i.push(.5*(u[l-1]+u[l]));else i=a;t=i.map((function(r){return w(r)}))}return sa[n]&&(t=t.map((function(r){return r[n]()}))),t},w.cache=function(r){return null!=r?(b=r,w):b},w.gamma=function(r){return null!=r?(p=r,w):p},w.nodata=function(r){return null!=r?(n=sa(r),w):n},w};function ga(r,e,n){for(var t=[],a=r<e,f=n?a?e+1:e-1:e,o=r;a?o<f:o>f;a?o++:o--)t.push(o);return t}var va=v,ma=pa,ya=y,ka=function(r,e,n){if(!ka[n])throw new Error("unknown blend mode "+n);return ka[n](r,e)},wa=function(r){return function(e,n){var t=ya(n).rgb(),a=ya(e).rgb();return ya.rgb(r(t,a))}},Ma=function(r){return function(e,n){var t=[];return t[0]=r(e[0],n[0]),t[1]=r(e[1],n[1]),t[2]=r(e[2],n[2]),t}};ka.normal=wa(Ma((function(r){return r}))),ka.multiply=wa(Ma((function(r,e){return r*e/255}))),ka.screen=wa(Ma((function(r,e){return 255*(1-(1-r/255)*(1-e/255))}))),ka.overlay=wa(Ma((function(r,e){return e<128?2*r*e/255:255*(1-2*(1-r/255)*(1-e/255))}))),ka.darken=wa(Ma((function(r,e){return r>e?e:r}))),ka.lighten=wa(Ma((function(r,e){return r>e?r:e}))),ka.dodge=wa(Ma((function(r,e){return 255===r||(r=e/255*255/(1-r/255))>255?255:r}))),ka.burn=wa(Ma((function(r,e){return 255*(1-(1-e/255)/(r/255))})));for(var Na=ka,_a=l.type,xa=l.clip_rgb,Aa=l.TWOPI,Ea=Math.pow,Fa=Math.sin,Pa=Math.cos,Oa=y,ja=v,Ga=Math.floor,Ra=Math.random,qa=o,La=Math.log,Ia=Math.pow,Ba=Math.floor,Ca=Math.abs,Da=function(r,e){void 0===e&&(e=null);var n={min:Number.MAX_VALUE,max:-1*Number.MAX_VALUE,sum:0,values:[],count:0};return"object"===qa(r)&&(r=Object.values(r)),r.forEach((function(r){e&&"object"===qa(r)&&(r=r[e]),null==r||isNaN(r)||(n.values.push(r),n.sum+=r,r<n.min&&(n.min=r),r>n.max&&(n.max=r),n.count+=1)})),n.domain=[n.min,n.max],n.limits=function(r,e){return Ya(n,r,e)},n},Ya=function(r,e,n){void 0===e&&(e="equal"),void 0===n&&(n=7),"array"==qa(r)&&(r=Da(r));var t=r.min,a=r.max,f=r.values.sort((function(r,e){return r-e}));if(1===n)return[t,a];var o=[];if("c"===e.substr(0,1)&&(o.push(t),o.push(a)),"e"===e.substr(0,1)){o.push(t);for(var u=1;u<n;u++)o.push(t+u/n*(a-t));o.push(a)}else if("l"===e.substr(0,1)){if(t<=0)throw new Error("Logarithmic scales are only possible for values > 0");var c=Math.LOG10E*La(t),i=Math.LOG10E*La(a);o.push(t);for(var l=1;l<n;l++)o.push(Ia(10,c+l/n*(i-c)));o.push(a)}else if("q"===e.substr(0,1)){o.push(t);for(var h=1;h<n;h++){var s=(f.length-1)*h/n,d=Ba(s);if(d===s)o.push(f[d]);else{var b=s-d;o.push(f[d]*(1-b)+f[d+1]*b)}}o.push(a)}else if("k"===e.substr(0,1)){var p,g=f.length,v=new Array(g),m=new Array(n),y=!0,k=0,w=null;(w=[]).push(t);for(var M=1;M<n;M++)w.push(t+M/n*(a-t));for(w.push(a);y;){for(var N=0;N<n;N++)m[N]=0;for(var _=0;_<g;_++)for(var x=f[_],A=Number.MAX_VALUE,E=void 0,F=0;F<n;F++){var P=Ca(w[F]-x);P<A&&(A=P,E=F),m[E]++,v[_]=E}for(var O=new Array(n),j=0;j<n;j++)O[j]=null;for(var G=0;G<g;G++)null===O[p=v[G]]?O[p]=f[G]:O[p]+=f[G];for(var R=0;R<n;R++)O[R]*=1/m[R];y=!1;for(var q=0;q<n;q++)if(O[q]!==w[q]){y=!0;break}w=O,++k>200&&(y=!1)}for(var L={},I=0;I<n;I++)L[I]=[];for(var B=0;B<g;B++)L[p=v[B]].push(f[B]);for(var C=[],D=0;D<n;D++)C.push(L[D][0]),C.push(L[D][L[D].length-1]);C=C.sort((function(r,e){return r-e})),o.push(C[0]);for(var Y=1;Y<C.length;Y+=2){var S=C[Y];isNaN(S)||-1!==o.indexOf(S)||o.push(S)}}return o},Sa={analyze:Da,limits:Ya},Ta=v,$a=v,za=Math.sqrt,Xa=Math.pow,Ua=Math.min,Va=Math.max,Wa=Math.atan2,Ka=Math.abs,Za=Math.cos,Ha=Math.sin,Ja=Math.exp,Qa=Math.PI,rf=v,ef=v,nf=y,tf=pa,af={cool:function(){return tf([nf.hsl(180,1,.9),nf.hsl(250,.7,.4)])},hot:function(){return tf(["#000","#f00","#ff0","#fff"]).mode("rgb")}},ff={OrRd:["#fff7ec","#fee8c8","#fdd49e","#fdbb84","#fc8d59","#ef6548","#d7301f","#b30000","#7f0000"],PuBu:["#fff7fb","#ece7f2","#d0d1e6","#a6bddb","#74a9cf","#3690c0","#0570b0","#045a8d","#023858"],BuPu:["#f7fcfd","#e0ecf4","#bfd3e6","#9ebcda","#8c96c6","#8c6bb1","#88419d","#810f7c","#4d004b"],Oranges:["#fff5eb","#fee6ce","#fdd0a2","#fdae6b","#fd8d3c","#f16913","#d94801","#a63603","#7f2704"],BuGn:["#f7fcfd","#e5f5f9","#ccece6","#99d8c9","#66c2a4","#41ae76","#238b45","#006d2c","#00441b"],YlOrBr:["#ffffe5","#fff7bc","#fee391","#fec44f","#fe9929","#ec7014","#cc4c02","#993404","#662506"],YlGn:["#ffffe5","#f7fcb9","#d9f0a3","#addd8e","#78c679","#41ab5d","#238443","#006837","#004529"],Reds:["#fff5f0","#fee0d2","#fcbba1","#fc9272","#fb6a4a","#ef3b2c","#cb181d","#a50f15","#67000d"],RdPu:["#fff7f3","#fde0dd","#fcc5c0","#fa9fb5","#f768a1","#dd3497","#ae017e","#7a0177","#49006a"],Greens:["#f7fcf5","#e5f5e0","#c7e9c0","#a1d99b","#74c476","#41ab5d","#238b45","#006d2c","#00441b"],YlGnBu:["#ffffd9","#edf8b1","#c7e9b4","#7fcdbb","#41b6c4","#1d91c0","#225ea8","#253494","#081d58"],Purples:["#fcfbfd","#efedf5","#dadaeb","#bcbddc","#9e9ac8","#807dba","#6a51a3","#54278f","#3f007d"],GnBu:["#f7fcf0","#e0f3db","#ccebc5","#a8ddb5","#7bccc4","#4eb3d3","#2b8cbe","#0868ac","#084081"],Greys:["#ffffff","#f0f0f0","#d9d9d9","#bdbdbd","#969696","#737373","#525252","#252525","#000000"],YlOrRd:["#ffffcc","#ffeda0","#fed976","#feb24c","#fd8d3c","#fc4e2a","#e31a1c","#bd0026","#800026"],PuRd:["#f7f4f9","#e7e1ef","#d4b9da","#c994c7","#df65b0","#e7298a","#ce1256","#980043","#67001f"],Blues:["#f7fbff","#deebf7","#c6dbef","#9ecae1","#6baed6","#4292c6","#2171b5","#08519c","#08306b"],PuBuGn:["#fff7fb","#ece2f0","#d0d1e6","#a6bddb","#67a9cf","#3690c0","#02818a","#016c59","#014636"],Viridis:["#440154","#482777","#3f4a8a","#31678e","#26838f","#1f9d8a","#6cce5a","#b6de2b","#fee825"],Spectral:["#9e0142","#d53e4f","#f46d43","#fdae61","#fee08b","#ffffbf","#e6f598","#abdda4","#66c2a5","#3288bd","#5e4fa2"],RdYlGn:["#a50026","#d73027","#f46d43","#fdae61","#fee08b","#ffffbf","#d9ef8b","#a6d96a","#66bd63","#1a9850","#006837"],RdBu:["#67001f","#b2182b","#d6604d","#f4a582","#fddbc7","#f7f7f7","#d1e5f0","#92c5de","#4393c3","#2166ac","#053061"],PiYG:["#8e0152","#c51b7d","#de77ae","#f1b6da","#fde0ef","#f7f7f7","#e6f5d0","#b8e186","#7fbc41","#4d9221","#276419"],PRGn:["#40004b","#762a83","#9970ab","#c2a5cf","#e7d4e8","#f7f7f7","#d9f0d3","#a6dba0","#5aae61","#1b7837","#00441b"],RdYlBu:["#a50026","#d73027","#f46d43","#fdae61","#fee090","#ffffbf","#e0f3f8","#abd9e9","#74add1","#4575b4","#313695"],BrBG:["#543005","#8c510a","#bf812d","#dfc27d","#f6e8c3","#f5f5f5","#c7eae5","#80cdc1","#35978f","#01665e","#003c30"],RdGy:["#67001f","#b2182b","#d6604d","#f4a582","#fddbc7","#ffffff","#e0e0e0","#bababa","#878787","#4d4d4d","#1a1a1a"],PuOr:["#7f3b08","#b35806","#e08214","#fdb863","#fee0b6","#f7f7f7","#d8daeb","#b2abd2","#8073ac","#542788","#2d004b"],Set2:["#66c2a5","#fc8d62","#8da0cb","#e78ac3","#a6d854","#ffd92f","#e5c494","#b3b3b3"],Accent:["#7fc97f","#beaed4","#fdc086","#ffff99","#386cb0","#f0027f","#bf5b17","#666666"],Set1:["#e41a1c","#377eb8","#4daf4a","#984ea3","#ff7f00","#ffff33","#a65628","#f781bf","#999999"],Set3:["#8dd3c7","#ffffb3","#bebada","#fb8072","#80b1d3","#fdb462","#b3de69","#fccde5","#d9d9d9","#bc80bd","#ccebc5","#ffed6f"],Dark2:["#1b9e77","#d95f02","#7570b3","#e7298a","#66a61e","#e6ab02","#a6761d","#666666"],Paired:["#a6cee3","#1f78b4","#b2df8a","#33a02c","#fb9a99","#e31a1c","#fdbf6f","#ff7f00","#cab2d6","#6a3d9a","#ffff99","#b15928"],Pastel2:["#b3e2cd","#fdcdac","#cbd5e8","#f4cae4","#e6f5c9","#fff2ae","#f1e2cc","#cccccc"],Pastel1:["#fbb4ae","#b3cde3","#ccebc5","#decbe4","#fed9a6","#ffffcc","#e5d8bd","#fddaec","#f2f2f2"]},of=0,uf=Object.keys(ff);of<uf.length;of+=1){var cf=uf[of];ff[cf.toLowerCase()]=ff[cf]}var lf=ff,hf=y;return hf.average=function(r,e,n){void 0===e&&(e="lrgb"),void 0===n&&(n=null);var t=r.length;n||(n=Array.from(new Array(t)).map((function(){return 1})));var a=t/n.reduce((function(r,e){return r+e}));if(n.forEach((function(r,e){n[e]*=a})),r=r.map((function(r){return new ta(r)})),"lrgb"===e)return ha(r,n);for(var f=r.shift(),o=f.get(e),u=[],c=0,i=0,l=0;l<o.length;l++)if(o[l]=(o[l]||0)*n[0],u.push(isNaN(o[l])?0:n[0]),"h"===e.charAt(l)&&!isNaN(o[l])){var h=o[l]/180*ua;c+=ca(h)*n[0],i+=ia(h)*n[0]}var s=f.alpha()*n[0];r.forEach((function(r,t){var a=r.get(e);s+=r.alpha()*n[t+1];for(var f=0;f<o.length;f++)if(!isNaN(a[f]))if(u[f]+=n[t+1],"h"===e.charAt(f)){var l=a[f]/180*ua;c+=ca(l)*n[t+1],i+=ia(l)*n[t+1]}else o[f]+=a[f]*n[t+1]}));for(var d=0;d<o.length;d++)if("h"===e.charAt(d)){for(var b=la(i/u[d],c/u[d])/ua*180;b<0;)b+=360;for(;b>=360;)b-=360;o[d]=b}else o[d]=o[d]/u[d];return s/=t,new ta(o,e).alpha(s>.99999?1:s,!0)},hf.bezier=function(r){var e=function(r){var e,n,t,a,f,o,u;if(2===(r=r.map((function(r){return new va(r)}))).length)e=r.map((function(r){return r.lab()})),f=e[0],o=e[1],a=function(r){var e=[0,1,2].map((function(e){return f[e]+r*(o[e]-f[e])}));return new va(e,"lab")};else if(3===r.length)n=r.map((function(r){return r.lab()})),f=n[0],o=n[1],u=n[2],a=function(r){var e=[0,1,2].map((function(e){return(1-r)*(1-r)*f[e]+2*(1-r)*r*o[e]+r*r*u[e]}));return new va(e,"lab")};else if(4===r.length){var c;t=r.map((function(r){return r.lab()})),f=t[0],o=t[1],u=t[2],c=t[3],a=function(r){var e=[0,1,2].map((function(e){return(1-r)*(1-r)*(1-r)*f[e]+3*(1-r)*(1-r)*r*o[e]+3*(1-r)*r*r*u[e]+r*r*r*c[e]}));return new va(e,"lab")}}else{if(!(r.length>=5))throw new RangeError("No point in running bezier with only one color.");var i,l,h;i=r.map((function(r){return r.lab()})),h=r.length-1,l=function(r){for(var e=[1,1],n=1;n<r;n++){for(var t=[1],a=1;a<=e.length;a++)t[a]=(e[a]||0)+e[a-1];e=t}return e}(h),a=function(r){var e=1-r,n=[0,1,2].map((function(n){return i.reduce((function(t,a,f){return t+l[f]*Math.pow(e,h-f)*Math.pow(r,f)*a[n]}),0)}));return new va(n,"lab")}}return a}(r);return e.scale=function(){return ma(e)},e},hf.blend=Na,hf.cubehelix=function(r,e,n,t,a){void 0===r&&(r=300),void 0===e&&(e=-1.5),void 0===n&&(n=1),void 0===t&&(t=1),void 0===a&&(a=[0,1]);var f,o=0;"array"===_a(a)?f=a[1]-a[0]:(f=0,a=[a,a]);var u=function(u){var c=Aa*((r+120)/360+e*u),i=Ea(a[0]+f*u,t),l=(0!==o?n[0]+u*o:n)*i*(1-i)/2,h=Pa(c),s=Fa(c);return Oa(xa([255*(i+l*(-.14861*h+1.78277*s)),255*(i+l*(-.29227*h-.90649*s)),255*(i+l*(1.97294*h)),1]))};return u.start=function(e){return null==e?r:(r=e,u)},u.rotations=function(r){return null==r?e:(e=r,u)},u.gamma=function(r){return null==r?t:(t=r,u)},u.hue=function(r){return null==r?n:("array"===_a(n=r)?0===(o=n[1]-n[0])&&(n=n[1]):o=0,u)},u.lightness=function(r){return null==r?a:("array"===_a(r)?(a=r,f=r[1]-r[0]):(a=[r,r],f=0),u)},u.scale=function(){return Oa.scale(u)},u.hue(n),u},hf.mix=hf.interpolate=Rt,hf.random=function(){for(var r="#",e=0;e<6;e++)r+="0123456789abcdef".charAt(Ga(16*Ra()));return new ja(r,"hex")},hf.scale=pa,hf.analyze=Sa.analyze,hf.contrast=function(r,e){r=new Ta(r),e=new Ta(e);var n=r.luminance(),t=e.luminance();return n>t?(n+.05)/(t+.05):(t+.05)/(n+.05)},hf.deltaE=function(r,e,n,t,a){void 0===n&&(n=1),void 0===t&&(t=1),void 0===a&&(a=1);var f=function(r){return 360*r/(2*Qa)},o=function(r){return 2*Qa*r/360};r=new $a(r),e=new $a(e);var u=Array.from(r.lab()),c=u[0],i=u[1],l=u[2],h=Array.from(e.lab()),s=h[0],d=h[1],b=h[2],p=(c+s)/2,g=(za(Xa(i,2)+Xa(l,2))+za(Xa(d,2)+Xa(b,2)))/2,v=.5*(1-za(Xa(g,7)/(Xa(g,7)+Xa(25,7)))),m=i*(1+v),y=d*(1+v),k=za(Xa(m,2)+Xa(l,2)),w=za(Xa(y,2)+Xa(b,2)),M=(k+w)/2,N=f(Wa(l,m)),_=f(Wa(b,y)),x=N>=0?N:N+360,A=_>=0?_:_+360,E=Ka(x-A)>180?(x+A+360)/2:(x+A)/2,F=1-.17*Za(o(E-30))+.24*Za(o(2*E))+.32*Za(o(3*E+6))-.2*Za(o(4*E-63)),P=A-x;P=Ka(P)<=180?P:A<=x?P+360:P-360,P=2*za(k*w)*Ha(o(P)/2);var O=s-c,j=w-k,G=1+.015*Xa(p-50,2)/za(20+Xa(p-50,2)),R=1+.045*M,q=1+.015*M*F,L=30*Ja(-Xa((E-275)/25,2)),I=-(2*za(Xa(M,7)/(Xa(M,7)+Xa(25,7))))*Ha(2*o(L)),B=za(Xa(O/(n*G),2)+Xa(j/(t*R),2)+Xa(P/(a*q),2)+I*(j/(t*R))*(P/(a*q)));return Va(0,Ua(100,B))},hf.distance=function(r,e,n){void 0===n&&(n="lab"),r=new rf(r),e=new rf(e);var t=r.get(n),a=e.get(n),f=0;for(var o in t){var u=(t[o]||0)-(a[o]||0);f+=u*u}return Math.sqrt(f)},hf.limits=Sa.limits,hf.valid=function(){for(var r=[],e=arguments.length;e--;)r[e]=arguments[e];try{return new(Function.prototype.bind.apply(ef,[null].concat(r))),!0}catch(r){return!1}},hf.scales=af,hf.colors=sn,hf.brewer=lf,hf}));


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#_interface_content{overflow:hidden!important}#content{display:flex;flex-direction:row}#vars{flex-grow:1}.pult_toolbar{padding:10px 20px;min-height:44px;background-color:var(--app-panel-color)}.pult_toolbar span{font-size:14px;color:var(--app-text-color);display:block;flex-grow:1}#values{box-sizing:border-box;display:flex;flex-direction:row;justify-content:stretch;width:100%}#values .value+.value{margin-left:20px}#values .value{opacity:1;border:1px solid transparent;background-color:var(--app-button-color);padding:10px;flex-grow:1;text-align:center;border-radius:5px;color:var(--app-active-text-color);cursor:pointer;user-select:none}#values .value a-icon{display:block;width:16px;height:16px;--color:var(--app-text-color)}#values .value:hover{color:var(--app-active-text-color);opacity:1}#values .value.disabled{opacity:1;border:1px solid var(--app-control-color);background:0 0!important;color:var(--app-comment-color);pointer-events:none}#values .value.disabled a-icon{--color:var(--app-comment-color)}#values .value.selected{border:1px solid var(--app-schedule-selected-color);opacity:1}.plan_data{padding:20px;overflow:auto;flex-shrink:0}#wrapper{height:100%}#pultvars{padding:0;height:100%}#opt_days{--padding:0}#grid_wrapper{overflow:hidden}#grid{flex-shrink:0;position:relative;box-sizing:border-box;user-select:none;cursor:pointer;border-top:none}#grid .caption{position:absolute;top:0;left:0;text-align:center;color:var(--app-text-color);cursor:default}#grid .row{position:relative;height:40px}#grid .cell{width:21px;height:41px;border:1px solid var(--app-schedule-grid-color);position:absolute;box-sizing:border-box}#grid .cell.selected{border:1px solid var(--app-schedule-selected-color)!important;z-index:2!important}#grid .cell>div{background-color:var(--control-on-color);width:100%;height:0;pointer-events:none;position:absolute;bottom:0;text-align:center}#grid .cell.valued{z-index:1;border:1px solid var(--app-schedule-grid-valued-color);background:repeating-linear-gradient(0deg,transparent 0,transparent 1px,var(--app-control-color) 1px,var(--app-control-color) 2px)}#grid .day{height:41px;position:absolute;box-sizing:border-box;border:1px solid var(--app-schedule-grid-color);text-align:center;color:var(--app-comment-color)}#grid .day.selected{color:var(--app-schedule-selected-color)}#grid .hours{position:relative;height:40px}#grid .hour{border:1px solid var(--app-schedule-grid-color);position:absolute;box-sizing:border-box;text-align:center;color:var(--app-comment-color)}#grid .hour.selected{color:var(--app-schedule-selected-color)}#grid .all{position:absolute;box-sizing:border-box;text-align:center}#plan_tabs{display:flex;flex-direction:row}#plan_tabs .plan{padding:7px 20px;font-size:14px;cursor:pointer}#plan_tabs .plan.selected{background-color:var(--app-grid-header-color);color:var(--app-active-text-color)}#plan_buttons{display:flex;align-items:center;flex-direction:row;padding:0 10px}#disabled{padding:10px 20px;background-color:var(--app-offline-color);color:var(--app-active-text-color);text-align:center;display:none}a-layout{flex-grow:1}#help{padding:20px;border-bottom:solid 1px var(--app-control-color)}#help>div{white-space:pre-line}#container{overflow:auto;display:flex;flex-direction:column;min-height:50%;border-bottom:solid 1px var(--app-control-color);border-right:solid 1px var(--app-control-color)}#_content.mobile{font-size:12px}#_content.mobile #grid_wrapper{padding:0;font-size:11px}#_content.mobile #lbl_show_vars{display:none}#_content.mobile .pult_toolbar a-button{max-width:32px}`,
	`<div id="pult_header">
	<div class="pult_split">
		<div class="pult_buttons">
			<a-select id="sel_enabled"></a-select>
			<hr>
			<a-button id='btn_save' disabled="1" hotkey="Ctrl+S" palette="anode-button-active" caption='${$save}'></a-button>
			<a-button id='btn_cancel' disabled="1"  caption='${$cancel}'></a-button>
			<a-button id='btn_test' caption='${$test}'></a-button>
			<hr>
			<a-button id='btn_menu' icon="/images/dotmenu.svg"></a-button>
			<a-button id='btn_help' icon="/images/help.svg"></a-button>
		</div>
	</div>
</div>
<div id="disabled">${$disabled_text}</div>

<a-layout id="layout" orientation="horizontal" stretch="slot1" size2="300" store="true" default_closed="2" >
	<div id="content" slot="1">

		<div id="container">
			<div id="plan_tabs"></div>
			<div id="plan_bar" class="pult_toolbar">
				<span>Почасовые задания</span>
				<a-options orientation="horizontal" id="opt_days"></a-options>
				<hr>
				<a-button id='btn_calendar' href="#interface/calendar" target="_blank" disabled="1" icon="/images/calendar.svg" caption='${$calendar}'></a-button>
			</div>
			
			<div id="grid_wrapper" class="plan_data">
				<div id='grid'></div>
			</div>
	
			<div id="values_bar" class="pult_toolbar">
				<span id="setupval">${$setup_values}</span>
				<a-button id='btn_settings2' icon="/images/options.svg" caption='${$do_settings}'></a-button>
			</div>
			<div id='values' class="plan_data"></div>
	
			<div id="vars_bar" class="pult_toolbar">
				<span>${$controlled_objects}</span>
				<a-button id='btn_add_var' icon="/images/plus.svg" caption='${$add}'></a-button>
				<a-button id='btn_delete_var' icon="/images/cross.svg" disabled="1" caption='${$delete}'></a-button>
				<hr>
				<a-button id='btn_delay' icon="/images/hourglass.svg" caption='${$delay}'></a-button>
				<hr>
				<a-label id="lbl_show_vars" caption='${$show_vars}'><a-checkbox id="chk_show_vars"></a-checkbox></a-label>
			</div>
			<div id='vars' class="plan_data">
				<a-pult-vars id="pultvars" empty="${$empty_vars}"></a-pult-vars>
			</div>			
		</div>

	</div>
	<div id="help" class="pult_big_help" slot="2">
		<h3>${$help}</h3>
		<div>${$help_text}</div>
	</div>
</a-layout>

`,
);


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let data;
let selection=[];
let dhcells=[];
let dhhours=[];
let dhdays=[];
let lastSelected;
let lastMouseDown;
let values, minValue, maxValue;
let minHeight, maxHeight;
let firstColor, lastColor;

let days=0;
let hours=0;


function create(){

    let mousePressed=false;
    document.body.addEventListener('mouseup',onmouseup);

    self.setHoldInterval();

    dom.pultvars.css=`#box{padding:1px}.var{padding:7px 10px;border-radius:0;margin-right:10px;margin-bottom:10px;border:1px solid var(--app-schedule-active-node-color);background-color:var(--app-schedule-active-node-color);color:var(--app-active-text-color)}.var a-checkbox{--on-color:var(--app-active-text-color)}.var.disabled{border:1px solid var(--app-control-color);background-color:transparent!important}.var.unknown{border:1px solid var(--app-error-color)!important;background-color:transparent!important;color:var(--app-error-color)!important}.var.unknown a-checkbox{--on-color:var(--app-error-color)}.var.selected{outline:var(--app-schedule-selected-color) solid 1px;background-color:var(--app-schedule-active-node-color);border-color:transparent;z-index:1}`;
    dom.pultvars.onclick=function (e){
        e.stopPropagation();
    }

    dom.pultvars.onselect=function (e){
        console.log(this.selection);
        dom.btn_delete_var.disabled=!this.selection.length;
    }
    
    dom.pultvars.onvarenabled=function (e){
        console.log(e.detail);
        needSave(true);
    }
    
    dom.pultvars.onvardisabled=function (e){
        console.log(e.detail);
        needSave(true);
    }

    dom.chk_show_vars.value=ls.get("schedule_show_node_vars",false);
    dom.chk_show_vars.onchange=function (e){
        ls.set("schedule_show_node_vars",e.detail);
        redrawVars();
    }

    dom.opt_days.list=[
        ['weekdays',$weekdays],
        ['holidays',$holidays],
    ];
    dom.opt_days.onchange=function (e){
        let c=this;
        let p=getActivePlan();
        applyTasks();
        
        let f=function (){
            p.layout=c.value;
            redrawPlanPanel();
            needSave(true);
            redrawLayout();
        }

        if(p.tasks.length){
            pult.showConfirm(self,{
                caption:$confirm_change_layout,
                html:$change_layout_text,
                onsubmit:f,
                oncancel:function (){
                    c.value=p.layout;
                }
            });
        }else{
            f();
        }
    }

    dom.container.onclick=function (e){
        select(false);
        dom.pultvars.unselect();
    }
    
    dom.grid.onclick=function (e){
        e.stopPropagation();
    }

    dom.btn_delete_var.onclick=function (e){
        e.stopPropagation();
        pult.showConfirm(self,$confirm_delete_vars,function (){
            let selection=dom.pultvars.selection;
            selection.sort((a, b) => (a > b ? -1 : 1));
            for(let i=0; i<selection.length; i++){
                let vi=selection[i];
                content.vars.splice(vi,1);
            }
            dom.pultvars.unselect();
            needSave(true);
            redrawVars();
    
        });
    }
    
    dom.container.onmousedown=function (e){
        let c=e.target;
        if(c.classList.contains('cell')){
            lastMouseDown=true;
            lastSelected=[c.day,c.hour];
        }else if(c.classList.contains('day')){
            lastMouseDown=true;
            lastSelected=[c.day,undefined];
        }else if(c.classList.contains('hour')){
            lastMouseDown=true;
            lastSelected=[undefined,c.hour];
        }
    }
    
    dom.container.onmousemove=function (e){
        if(lastMouseDown){
            let c=e.target;
            if(c.classList.contains('cell') || c.classList.contains('day') || c.classList.contains('hour')){
                if(e.ctrlKey){
                    select(true,c.day,c.hour,true,true);
                }else{
                    select(false);
                    select(true,c.day,c.hour,true);
                }
            }
        }
    }
   

    dom.sel_enabled.list=[
        [0,$disabled],
        [1,$enabled],
    ];

    dom.sel_enabled.onchange=function (e){
        content.enabled=Number(this.value);
        needSave(true);
    }

    dom.btn_save.onclick=function (e){

        applyTasks();

        pult.fdb.saveJsonDoc(self,self.path,'@content.json',content,function (req,res,err){
            if(err){
                pult.showError(self,err);
            }else{
                needSave(false);
                refreshEnabled();
            }
        });
    }

    dom.btn_cancel.onclick=function (e){
        pult.showConfirm(self,$cancel_changes,function (e){
            needSave(false);
            loadContent();
        });
    }

    dom.btn_help.onclick=function (){
        dom.layout.toggle(2);
    }

    dom.btn_add_var.onclick=function (){
        showAddVar();
    }
    

    dom.btn_settings2.onclick = function (){

        let settings=Util.clone(content.settings);

        let templates=[
            {
                template_name:$template_name_onoff,
                values:[
                    {text:$template_value_text_off,value:0,},
                    {text:$template_value_text_on,value:1,},
                ]
            },
            {
                template_name:$template_name_setpoint,
                values:[
                    {value:15,height:10,color:self.getCSSVarValue('--control-ventilation-cold-color')},
                    {},
                    {},
                    {},
                    {},
                    {},
                    {},
                    {},
                    {},
                    {},
                    {value:25,height:100,color:self.getCSSVarValue('--control-ventilation-warm-color')},
                ]
            }
        ];

        let templates_list=[];

        for(let i=0; i<templates.length; i++){
            templates_list.push([i,templates[i].template_name]);
        }

        let f=pult.showForm(self,{
            caption:$schedule_settings,
            html:[
                {
                    tag:'a-form-row',
                    caption:$apply_template,
                    html:{
                        name:'template',
                        tag:'a-select',
                        undefined:true,
                        list:templates_list,
                    }
                },
                {
                    tag:'a-form-row',
                    caption:$values_count,
                    html:{
                        name:'values_count',
                        tag:'a-select',
                        list:[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21],
                        value:settings.values.length
                    }
                },
                {
                    tag:'a-grid',
                    name:'grid',
                    show_settings:false,
                    editor_save_by_exit:true,
                    style:{
                        flexShrink:1,
                        borderRadius:'5px',
                    },
                    class:'mt10',
                }
            ],
            onsubmit:function (){
                settings.values=f.dom.grid.records;
                applyTasks();
                content.settings=settings;
                needSave(true);
                redrawValues();
                redrawTasks();
                refreshSelectedValues();
            },
            onchange:function (e){
                let c=e.detail;
                if(c.name==='template'){
                    let t=templates[c.value];
                    settings=t;
                    f.dom.values_count.value=settings.values.length;
                    refreshGrid();
                }else if(c.name==='values_count'){
                    refreshGrid();
                }
            }
        });

        f.dom._content.style.display='flex';
        f.dom._content.style.flexDirection='column';
        f.dom._content.style.overflow='hidden';
        refreshGrid();

        function refreshGrid(){
            let grid=f.dom.grid;

            grid.onkeypress=function (e){
                e.stopPropagation();
            }
    
            grid.columns=[
                {
                    key:'value',
                    caption:$value,
                    edit:'number',
                    placeholder:'auto',
                },
                {
                    key:'text',
                    caption:$caption,
                    placeholder:'auto',
                    edit:'text',
                },
                {
                    key:'height',
                    caption:$height,
                    edit:'number',
                    placeholder:'auto',
                },
                {
                    key:'color',
                    caption:$color,
                    placeholder:'auto',
                    edit:'edit',
                    edit_params:{
                        formfunc:function (c){
                            pult.showColorPicker(self,c);
                        }
                    }

                },
            ];
    
            let values=[];
            for(let i=0; i<f.dom.values_count.value; i++){
                let v=settings.values[i] || {};
                values.push(v);
            }
            grid.records=values;
        }

    }

    dom.btn_test.onclick=function (){

        let vv=[];
        for(let i=0; i<values.length; i++){
            let v=values[i];
            vv.push([v.value, v.text ? v.text+' ('+v.value+')' : v.value]);
        }

        let vars=dom.pultvars.fullList;

        if(vars?.length){

            let varlist=[];
            let subvars=[];

            for(let i=0; i<1; i++){
                for(let i=0; i<vars.length; i++){
                    let v=vars[i];
                    subvars.push(v.globalName);
                    varlist.push({
                        tag:'div',
                        class:v.enabled?'':'comment',
                        html:[
                            {
                                tag:'span',
                                html:v.fullVarName,
                            },
                            {
                                tag:'span',
                                html:'0',
                                id:'var_'+v.globalName,
                            },
                        ],
                        style:{
                            padding:'5px 0px 5px 0px',
                            display:'flex',
                            flexDirection:'row',
                            justifyContent:'space-between',
                            borderBottom:'dotted 1px var(--app-modal-form-control-color)',
                        }
                    });
                }
            }

            let f=pult.showForm(self,{
                caption:$schedule_test,
                hideOnSubmit:false,
                hide_by_click:false,
                submit:$start,
                width:500,
                html:[
                    {
                        tag:'div',
                        html:$test_help,
                        class:'mb10 comment',
                    },
                    'hr',
                    {
                        tag:'a-form-row',
                        caption:$setup_value,
                        html:{
                            name:'value',
                            tag:'a-select',
                            list:vv,
                            value:vv[0][0],
                        }
                    },
                    {
                        tag:'a-form-row',
                        caption:$countdown,
                        html:{
                            name:'countdown',
                            tag:'span',
                            html:'00:00:10',
                            class:'comment',
                            style:{
                                fontSize:'16px',
                                position:'relative',
                                top:'1px',
                            }
                        }
                    },
                    'hr',
                    {
                        tag:'div',
                        class:'pult_split comment mb10 mt10',
                        html:`<span>${$vars}</span><span>${$current_values}</span>`,
                    },
                    {
                        tag:'div',
                        html:varlist,
                        id:'vardiv',
                        style:{
                            maxHeight:'300px',
                            overflow:'auto',
                            background:'var(--app-background-color)',
                            padding:'10px',
                        }
                    }
                ],
                onsubmit:function (e){
                    
                    let value=Number(e.detail.value);    

                    let p=getActivePlan();
                    let test_task=p.tasks.find(function (t){
                        if(t.test) return true;
                    });

                    if(!test_task){
                        test_task={
                            test:true,
                        };
                        p.tasks.push(test_task);
                    }

                    let start_time=Time.timestamp+10;
                    f.dom.countdown.innerHTML=`00:00:10`;
                    
                    let s=Time.timestampToSecond(start_time);
                    let m=Time.timestampToMinute(start_time);
                    let h=Time.timestampToHour(start_time);
                    let D=Time.timestampToMonthDay(start_time);
                    let M=Time.timestampToMonth(start_time);

                    let cron=[s,m,h,D,M,'*'].join(' ');
                    
                    test_task.till=Time.timestamp+20;
                    test_task.cron=cron;
                    test_task.value=value;
                    
                    pult.fdb.saveJsonDoc(self,self.path,'@content.json',content,function (req,res,err){
                        if(err){
                            pult.showError(self,err);
                        }else{

                            let n=10;
                            f.dom.countdown.classList.remove('comment');
                            let int=setInterval(function (){
                                n--;
                                if(n>=0) f.dom.countdown.innerHTML=`00:00:0${n}`;
                            },1000);

                            setTimeout(function (){
                                clearInterval(int);
                                f.dom.countdown.classList.add('comment');
                                f.reset();             
                            },10000);  
                        }
                    });        
                },
                oncancel:function (e){
                    console.log('cancel');            
                    pult.unsubscribeVars(self);
                }
            });


            pult.subscribeVars(self,subvars,function (data){
                let vardiv=f.dom.vardiv;
                for(let i=0; i<data.length; i++){
                    let [name,time,value,error]=data[i];
                    for(let i=0; i<vardiv.children.length; i++){
                        let s=vardiv.children[i].children[1];
                        if(s.id==='var_'+name){
                            s.innerHTML=error ? `<error>${pult.errstr(error)}</error>` : value;
                        }
                    }
                }
            });
        }else{

            pult.showInfo(self,$no_vars_added);

        }

    }

    dom.btn_delay.onclick=function (e){
        pult.showForm(self,{
            width:500,
            caption:$delay_caption,
            submitFocus:false,
            html:[
                {
                    tag:'div',
                    class:'comment mb20',
                    html:$delay_comment
                },
                {
                    tag:'a-form-row',
                    caption:$delay_s,
                    html:{
                        name:'delay',
                        tag:'a-number',
                        set_focus:true,
                        width:100,
                        value:Util.round(content.vardelay/1000,3),
                    }
                }
            ],
            onsubmit:function (e){
                content.vardelay=e.detail.delay*1000;
                dom.btn_delay.caption=Util.format($delay,Util.round(content.vardelay/1000,3));
                needSave(true);
            }
        });
    }

}

function createPlan(planData){
    let name=getActivePlan()?.name;
    let repl=false;
    for(let i=$plan_letters.length-1; !repl && i>=0; i--){
        let l=$plan_letters[i];
        for(let j=0; !repl && j<content.plans.length; j++){
            let p=content.plans[j];
            if(p.name.endsWith(' '+l)){
                i=i+1;
                if(i>=$plan_letters.length) i=0;
                l=$plan_letters[i];
                name=name.substring(0,name.length-2)+' '+l;
                repl=true;
            }
        }
    }

    if(!repl){
        name=Util.getNextName(name,Object.keys(content.plans));
    }

    let f=pult.showForm(self,{
        caption:$add_plan,
        submitFocus:false,
        html:[
            {
                tag:'a-input',
                value:name,
                name:'name',
                set_focus:true,
                properties:{
                    validation_events:'submit',
                    validation:[
                        'notEmpty',
                        {
                            method:function (v){
                                if(content.plans.find(function (p){
                                    if(p.name===v) return true;
                                })){
                                    return $plan_error_exists;
                                }
                            }
                        }
                    ],
                }
            }
        ],
        onsubmit:function (e){
            let name=e.detail.name.trim();
            let data=Util.def({
                name:name,
            },planData);
            content.plans.push(data);
            redrawPlans();
            redrawMenu();                
            selectPlan(name);                
        }
    });

    
}

function getTaskDayHour(t){
    let cron=t.cron?.split(' ');
    let h,d;
    if(cron && cron.length===6){
        h=Number(cron[2]);
        d=Number(cron[5]);
    }else if(cron && cron.length===5){
        h=Number(cron[1]);
        d=Number(cron[4]);
    }
    return [d,h];
}

function onmouseup(){
    lastMouseDown=undefined;
}

function destroy(){
    document.body.removeEventListener('mouseup',onmouseup);
    self.clearHoldInterval();
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}


function update_path(path){
    self.holdObject(self.path);
    pult.showObject(self,self.path,null,function (o){
        if(!(o._access & pult.ACS_TYPE_EDIT)){
            pult.showInfo(self,$nosave_text);
        }
        loadContent();
    });
}

function loadContent(){
    
    dom.pultvars.current_widget=self;
    dom.pultvars.current_project=pult.getProjectPath(self.__path);

    pult.fdb.loadDoc(self,self.path,{
        file:'@content.json',
        format:'json',
    },function (req,res,err){
        if(err && err.code!==FDB_ERROR_DOC_NOT_FOUND){
            pult.showModalError(self,err);
        }else{
            content=Util.def(res?.data,pult.defaultSchedule);
            if(!content.plans) content.plans=pult.defaultSchedule.plans;
            if(!content.settings) content.settings=pult.defaultSchedule.settings;
            if(!content.vars) content.vars=[];
            if(!content.vardelay) content.vardelay=0;
            redrawValues();
            redrawPlans();
            redrawMenu();
            selectPlan();
            redrawVars();
        }
    });
}

function redrawTasks(){
    let p=getActivePlan();
    let tasks=p.tasks;
    for(let i=0; i<tasks.length; i++){
        let t=tasks[i];
        if(!t.test){
            let [d,h]=getTaskDayHour(t);

            if(p.layout==='holidays'){
                d-=8;
            }else{
                d-=1;
            }

            setValue(d,h,t.value);
        }
    }
}

function applyTasks(){
    let p=getActivePlan();
    p.tasks=[];
    for(let i=0; i<dhcells.length; i++){
        
        let c=dhcells[i];

        let day,hour;
        if(p.layout==='holidays'){
            day=c.day+8;
            hour=c.hour;
        }else{
            day=c.day+1;
            hour=c.hour;
        }

        if(c.value!==undefined){
            p.tasks.push({
                cron:`0 0 ${hour} * * ${day}`,
                value: c.value,
            });
        }

    }
}

function redrawValues(){

    values=[];
    maxValue=undefined;
    minValue=undefined;
    maxHeight=undefined;
    minHeight=undefined;
    firstColor=undefined;
    lastColor=undefined;

    dom.values.innerHTML='';
    let vv=Util.clone(content.settings.values);
    
    let vd=Util.create(dom.values,'.value');
    vd.innerHTML='<a-icon src="/images/close.svg"></a-icon>';
    vd.onclick=function (e){
        e.stopPropagation();
        needSave(true);
        for(let i=0; i<selection.length; i++){
            let [d,h]=selection[i];
            setValue(d,h,undefined);
            refreshSelectedValues();
        }
    }

    
    
    let value_step=1;
    let height_step=100/(vv.length-1);
    let fv=vv[0];
    let lv=vv[vv.length-1];
    
    

    if(fv.value!==undefined && lv.value!==undefined) value_step=(lv.value-fv.value)/(vv.length-1);
    if(fv.height!==undefined && lv.height!==undefined) height_step=(lv.height-fv.height)/(vv.length-1);
    if(fv.color!==undefined && lv.color!==undefined) {firstColor=fv.color; lastColor=lv.color}
    let pv;
    for(let i=0; i<vv.length; i++){
        let v=vv[i];
        if(v.value===undefined && pv!==undefined) v.value=pv.value+value_step;
        if(v.height===undefined && pv!==undefined) v.height=(pv.height ?? 0)+height_step;
        pv=v;
        
        let value=Number(v.value);
        if(maxValue===undefined || value>maxValue) maxValue=value;
        if(minValue===undefined || value<minValue) minValue=value;

        values.push(v);
    }

    for(let i=0; i<vv.length; i++){
        let v=vv[i];
        let value=Number(v.value);
        if(v.height===undefined) v.height=((value-minValue)/(maxValue-minValue)*100);
        if(v.color===undefined && firstColor && lastColor) v.color=chroma.mix(firstColor,lastColor,v.height/100);
        if(v.color===undefined && value>minValue) v.color='var(--control-on-color)';

        let vd=Util.create(dom.values,'.value');
        vd.style.width=(100/vv.length)+'%';
        vd.innerHTML=v.text ?? v.value;
        vd.value=value;
        vd.style.background=v.color ? v.color : 'repeating-linear-gradient(0deg,transparent 0px,transparent 1px,var(--app-control-color) 1px, var(--app-control-color) 2px)';

        vd.onclick=function (e){
            e.stopPropagation();
            needSave(true);
            for(let i=0; i<selection.length; i++){
                let [d,h]=selection[i];
                setValue(d,h,value);
                refreshSelectedValues();
            }
        }
    }
}

function getActivePlan(){
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.active) return p;
    }
    return content.plans[0];
}

function getActivePlanIndex(){
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.active) return i;
    }
    return 0;
}

function selectPlan(plan){

    if(!plan){
        plan=getActivePlan()?.name;
    }
    let curPlan=getActivePlan()?.name;

    if(curPlan!==plan){
        needSave(true);
    }

    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        p.active=false;
    }

    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.name===plan){
            p.active=true;
            break;
        }
    }

    for(let i=0; i<dom.plan_tabs.children.length; i++){
        let n=dom.plan_tabs.children[i];
        if(n.plan===plan){
            n.classList.add('selected');
        }else{
            n.classList.remove('selected');
        }
    }

    let p=getActivePlan();
    if(!p.tasks) p.tasks=[];
    data=p.tasks;

    select(false);
    redrawData();
    

}

function redrawPlans(){
    dom.plan_tabs.innerHTML='';
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        let n=document.createElement('div');
        n.classList='plan';
        n.innerHTML=p.name;
        n.plan=p.name;
        dom.plan_tabs.appendChild(n);
        n.onclick=function (e){
            selectPlan(n.plan);
        }
    }
}


function redrawMenu(){
    let menu=[];
    
    menu.push({
        caption:$add_plan,
        onclick:function (){
            createPlan();
        }
    });
    
    menu.push({
        caption:$clone_plan,
        onclick:function (){
            let p=getActivePlan();
            createPlan(p);
        }
    });

    menu.push({
        caption:$rename_plan,
        onclick:function (){
            let f=pult.showForm(self,{
                caption:$rename_plan,
                submitFocus:false,
                html:[
                    {
                        tag:'a-input',
                        value:getActivePlan()?.name,
                        name:'name',
                        set_focus:true,
                        properties:{
                            validation_events:'submit',
                            validation:[
                                'notEmpty',
                                {
                                    method:function (v){
                                        if(content.plans.find(function (p){
                                            if(p.name===v) return true;
                                        })){
                                            return $plan_error_exists;
                                        }
                                    }
                                }
                            ],
                        }
                    }
                ],
                onsubmit:function (e){
                    let name=e.detail.name.trim();
                    let pp={};
                    let p=getActivePlan();
                    p.name=name;
                    redrawPlans(); 
                    redrawMenu();               
                    selectPlan(name);                
                }
            });
        }
    });

    if(content.plans.length>=2){
        menu.push({
            caption:$delete_plan,
            onclick:function (){
                pult.showConfirm(self,Util.format($confirm_delete_plan,getActivePlan()?.name),function(){
                    let i=getActivePlanIndex();
                    console.log(i);
                    content.plans.splice(i,1);
                    needSave(true);
                    redrawPlans();
                    redrawMenu();
                    selectPlan(getActivePlan()?.name);
                });
            }
        });
    }

    menu.push("-");

    
    menu.push({
        caption:$clone_schedule,
        onclick:function (){
            pult.request(self,'fdb_nextname',{
                path:self.path
            },function (req,res,err){
                if(err){
                    pult.showError(self,err);
                }else{
                    path=res;
                    let name=Util.getFileTitle(path);
                    let f=pult.showForm(self,{
                        caption:$clone_schedule,
                        width:400,
                        submitFocus:false,
                        html:[
                            {
                                tag:'a-input',
                                value:name,
                                width:'100%',
                                name:'name',
                                set_focus:true,
                                validation:['fileName'],
                            },
                        ],
                        onsubmit:function (e){
                            let name=e.detail.name;
                            let dest=Util.getFilePath(self.path) + '/' + name + '.schedule';
                        
                            pult.fdb.copy(self,{
                                path:self.path,
                                dest:dest,
                            },function (req,res,err){
                                if(err){
                                    pult.showError(self,err);
                                    f.show();
                                }else{
                                    pult.navigate(`#interface/simple_schedule?path=${dest}`);
                                }
                            });
                        }
                    });                
                }
            });
        }
    });

    menu.push({
        caption:$rename_schedule,
        onclick:function (){
            let f=pult.showForm(self,{
                caption:$rename_schedule,
                width:400,
                submitFocus:false,
                html:[
                    {
                        tag:'a-input',
                        value:Util.getFileTitle(self.path),
                        width:'100%',
                        name:'name',
                        set_focus:true,
                        validation:['fileName'],
                    },
                ],
                onsubmit:function (e){
                    let name=e.detail.name;
                    let dest=Util.getFilePath(self.path) + '/' + name + '.schedule';
                   
                    pult.fdb.move(self,{
                        path:self.path,
                        dest:dest,
                    },function (req,res,err){
                        if(err){
                            pult.showError(self,err);
                            f.show();
                        }else{
                            pult.navigate(`#interface/simple_schedule?path=${dest}`);
                        }
                    });
                }
            });                
        }
    });


    menu.push({
        caption:$delete_schedule,
        onclick:function (e){
            pult.showConfirm(self,$confirm_delete_schedule,function (){
                pult.request(self,'fdb_delete',{
                    path:self.__path,
                },function (req,res,err){
                    if(err){
                        pult.showError(self,err);
                    }else{
                        let pp=Util.getFilePath(self.__path);
                        pult.navigate(`#interface/schedules?path=${pp}`);
                    }
                });
            });
        }
    });


    dom.btn_menu.popmenu=menu;
}


function redrawData(){
    refreshEnabled();
    redrawPlanPanel();
    redrawLayout();
    redrawTasks();
}

function redrawPlanPanel(){
    let p=getActivePlan();
    dom.opt_days.value = p.layout || 'weekdays';
    dom.btn_calendar.disabled=(p.layout!=='holidays');
}

function redrawLayout(){
    

    dhcells=[];
    dhhours=[];
    dhdays=[];

    
    let plan=getActivePlan();
    let wdays;
    if(plan.layout==='holidays'){
        wdays=[$dw_wd,$dw_hd];
    }else{
        wdays=[$dw_mo,$dw_tu,$dw_we,$dw_th,$dw_fr,$dw_sa,$dw_su];
    }

    hours=24;
    days=wdays.length;


    let grid=dom.grid;
    grid.innerHTML='';

    let w=40;
    let h=40;
    let padding=40;
    
    if(Util.isMobile){
        padding=0;
        w=(document.body.offsetWidth-2)/26;
    }


    let gw=(w*2+w*24+2);
    grid.style.width=gw+'px';
    grid.style.minWidth=gw+'px';
    grid.style.height=(h*wdays.length + h*2 +1)+'px';

    dom.container.style.minWidth=dom.container.style.width=(gw+padding)+'px';
    


    // draw cells

    for(let i=0; i<days; i++){
        for(let j=0; j<hours; j++){

            let e=Util.create(grid,'.cell');
            e.style.left=(w*j+w)+'px';
            e.style.top=(h*i+h)+'px';
            e.style.width=(w+1)+'px';
            e.style.height=(h+1)+'px';
            e.style.lineHeight=(h+1)+'px';
            e.day=i;
            e.hour=j;
            e.onclick=function (e){
                if(e.shiftKey){
                    select(true,i,j,true)
                }else if(e.ctrlKey){
                    select(undefined,i,j);
                }else{
                    select(false);
                    select(true,i,j);
                }
            }
            dhcells.push(e);
            let ev=Util.create(e);
        }
    }

    // draw days

    function createDay(day,left){
        let e=Util.create(grid,'.day');
        e.style.left=(left)+'px';
        e.style.top=(h*day+h)+'px';
        e.style.width=(w+1)+'px';
        e.style.height=(h+1)+'px';
        e.style.lineHeight=(h+1)+'px';
        e.day=day;
        e.hour=undefined;
        e.innerHTML=wdays[day];
        e.onclick=function (e){
            if(e.shiftKey){
                select(true,day,undefined,true)
            }else if(e.ctrlKey){
                select(undefined,day,undefined);
            }else{
                select(false);
                select(true,day,undefined);
            }
        }
        dhdays.push(e);
    }

    for(let i=0; i<days; i++){
        createDay(i,0);
        createDay(i,w*(hours+1));
    }

    // draw hours

    function createHour(hour,top){
        let e=Util.create(grid,'.hour');
        e.style.left=(w*hour+w)+'px';
        e.style.top=(top)+'px';
        e.style.width=(w+1)+'px';
        e.style.height=(h+1)+'px';
        e.style.lineHeight=(h+1)+'px';
        e.day=undefined;
        e.hour=hour;
        e.innerHTML=hour;
        e.onclick=function (e){
            if(e.shiftKey){
                select(true,undefined,hour,true)
            }else if(e.ctrlKey){
                select(undefined,undefined,hour);
            }else{
                select(false);
                select(true,undefined,hour);
            }
        }
        dhhours.push(e);
    }

    for(let j=0; j<hours; j++){
        createHour(j,0);
        createHour(j,h*(days+1));
    }

}

function refreshEnabled(){
    self.status = content.enabled ? 2 : 0;
    dom._interface_status.style.display='none';
    dom.sel_enabled.value=content.enabled;
    if(content.enabled){
        dom.disabled.style.display='none';
    }else{
        dom.disabled.style.display='block';
    }
}



function needSave(need){
    pult.needSave=need;
    dom.btn_save.disabled=!need;
    dom.btn_cancel.disabled=!need;
    dom.btn_test.disabled=need;
}

function showAddVar(){
    let ri=selection[0];
    let cronStr=getLastValue(ri,'cron');
    pult.showSelectVar(self,function (v){
        let vn=v.sameProject ? v.projectName : v.globalName;
        if(!content.vars) content.vars=[];
        if(!content.vars.find(function (v){
            if(v.name===vn) return true;
        })){
            content.vars.push({enabled:true,name:vn});
            needSave(true);
        }
    });
}

function getCell(d,h){
    let i=d*hours+h;
    return dhcells[i];
}

function select(v,d,h,shift,ctrl){

    let arr;

    if(shift){
        arr=[];
        let dd,dh,dx,dy;

        if(lastSelected[0]===undefined || d===undefined){
            dd=-days;
            dy=1;
            d=0;
        }else{
            dd=d-lastSelected[0];
            dy=dd>0 ? -1 : 1;
        }
        if(lastSelected[1]===undefined || h===undefined){
            dh=-hours;
            dx=1;
            h=0;
        }else{
            dh=h-lastSelected[1];
            dx=dh>0 ? -1 : 1;
        }

        for(let y=d; y!=d-dd+dy; y+=dy){
            for(let x=h; x!=h-dh+dx; x+=dx){
                arr.push([y,x]);
            }
        }

        
    }else{
        arr=[[d,h]];
        if(v) lastSelected=[d,h];
    }
       
    

    requestAnimationFrame(function (){

        if(shift && !ctrl){
            selection=[];
            for(let i=0; i<dhcells.length; i++){
                let c=dhcells[i];
                c.classList.toggle('selected',false);
            }
        }

        for(let i=0; i<dhcells.length; i++){
            let c=dhcells[i];
            for(let i=0; i<arr.length; i++){
                let [d,h]=arr[i];
                if((d===undefined || d===c.day) && (h===undefined || h===c.hour)){
                    if(v===undefined) v=!c.classList.contains('selected');
                    c.classList.toggle('selected',v);
                    let si=selectedIndex(c.day,c.hour);
                    if(v && si<0){
                        selection.push([c.day,c.hour]);
                    }else if(!v && si){
                        selection.splice(si,1);
                    }
                }
            }
        }

        for(let i=0; i<dhdays.length; i++){
            let c=dhdays[i];
            c.classList.toggle('selected',false);
        }

        for(let i=0; i<dhhours.length; i++){
            let c=dhhours[i];
            c.classList.toggle('selected',false);
        } 

        for(let i=0; i<selection.length; i++){
            let [d,h]=selection[i];
            for(let i=0; i<dhdays.length; i++){
                let c=dhdays[i];
                if(c.day===d) c.classList.toggle('selected',true);
            }
            for(let i=0; i<dhhours.length; i++){
                let c=dhhours[i];
                if(c.hour===h) c.classList.toggle('selected',true);
            }    
        }

        refreshSelectedValues();

    });
}

function refreshSelectedValues(){
    let value=null;
    for(let i=0; i<selection.length; i++){
        let [d,h]=selection[i];
        let c=getCell(d,h);
        if(value===null || value===c.value){
            value=c.value;
        }else{
            value=undefined;
        }
    }

    let bb=dom.values.children;
    for(let i=0; i<bb.length; i++){
        let b=bb[i];
        b.classList.toggle('disabled',!selection.length);
        b.classList.toggle('selected',value!==undefined && b.value===value);
    }

    dom.setupval.innerHTML=$setup_values + (value===undefined || value===null ? '' : ': '+value);

}

function selectedIndex(d,h){
    for(let i=0; i<selection.length; i++){
        let dh=selection[i];
        if(dh[0]===d && dh[1]===h) return i;
    }
    return -1;
}

function setValue(d,h,v){


    let c=getCell(d,h);
    if(c){
        c.value=v;
        
        if(v===undefined){
            
            c.classList.toggle('valued',false);
            c.children[0].style.height='0%';
            c.children[0].style.background='transparent';
            
        }else{
            
            c.classList.toggle('valued',true);

            let val=values.find(function (val){
                if(Number(val.value)===v){
                    return true;
                }
            });

            let height;
            let color;

            if(val){
                color=val.color;
                height=val.height;
                c.children[0].innerHTML='';
            }else{
                height=100;
                c.children[0].innerHTML='?';
            }

            
            if(height===undefined) height=((v-minValue)/(maxValue-minValue)*100);
            
            if(height>100) height=100;
            if(height<0) height=0;
            
            if(color===undefined && v>minValue) color='var(--control-on-color)';
            if(color===undefined) color='transparent';

            c.children[0].style.height=height+'%';
            c.children[0].style.background=color;
        }
    }
}



function showAddVar(){
    pult.showSelectVar(self,function (v){
        let vn=v.sameProject ? v.projectName : v.globalName;
        console.log(vn);    

        if(!content.vars.find(function (v){
            if(v.name===vn) return true;
        })){
            content.vars.push({enabled:true,name:vn});
            redrawVars();
            needSave(true);
        }

    });
}

function redrawVars(){
    dom.btn_delay.caption=Util.format($delay,Util.round(content.vardelay/1000,3));
    dom.pultvars.show_var_name=dom.chk_show_vars.value;
    dom.pultvars.value=content.vars;
}