/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Система";
  var $version="Версия";
  var $version_format="%s от %s";
  
  var $common="Общая информация";
  var $vars="Переменные";
  var $gateways="Шлюзы";
  var $services="Сервисы";
  var $resources="Ресурсы";
  var $time_startup="Время запуска";
  var $time_stamp="Время на сервере";
  
  var $physical_vars="Физические / Лицензия";
  var $virtual_vars="Виртуальные";
  var $total_vars="Всего переменных";
  var $trend_vars="Тренды";
  var $alarm_vars="Тревоги";
  var $signals_per_second="Сигналы в секунду";
  var $gateway_count="Количество шлюзов";
  var $gateway_online="Шлюзов онлайн";
  var $gateway_incoming_traffic="Входящий трафик";
  var $gateway_outgoing_traffic="Исходящий трафик";
  var $gateway_incoming_traffic_per_second="Скорость вх. трафика";
  var $gateway_outgoing_traffic_per_second="Скорость исх. трафика";
  var $service_count="Всего сервисов";
  var $service_runnings="Запущено";
  var $service_errors="С ошибками";
  var $cpu_usage="Использование ЦП, мгн.";
  var $cpu_usage_avg="Использование ЦП, срдн.";
  var $mem_usage="Использование ОЗУ";
  var $mem_total="Всего ОЗУ";
  var $space_total="Объем диска";
  var $space_free="Свободное место";
  var $connections="Активные соединения";
  var $subscriptions="Активные подписки";
  var $accepts="Счетчик подключений";

  var $info="Информация";
  var $control="Управление";
  var $logs="Логи";
  var $name="Сервис";
  var $status="Статус";
  var $errors="Ошибки";
  var $settings="Настройки";
  var $service_settings="Настройки сервиса";
  var $status_running="Запущен";
  var $status_stopped="Остановлен";
  var $status_disabled="Отключен";
  var $restart="Рестарт";
  var $start="Старт";
  var $stop="Стоп";
  var $enable="Включить";
  var $disable="Отключить";
  var $control_help="Отключенные сервисы не будут запущены до их включения.<br> Остановленные сервисы будут запущены при перезагрузке устройства.";
  var $mem_usage="Использование памяти";
  var $error_text="Последняя ошибка";
  var $error_time="Время ошибки";
  var $location="Размещение";
  var $exe="Исполняемый файл";
  var $config="Файл настроек";
  var $delete="Удалить";
  var $refresh="Обновить";
  var $nofiles="Нет файлов логов";
  var $delete_confirm="Удалить все файлы логов?";
  var $reboot="Перезагрузка";

}else{
  var $title="System";
  var $version="Version";
  var $version_format="%s from %s";
  
  var $common="General information";
  var $vars="Variables";
  var $gateways="Gateways";
  var $services="Services";
  var $resources="Resources";
  var $time_startup="Startup time";
  var $time_stamp="Server time";

  var $total_vars="Total variables";
  var $virtual_vars="Virtual";
  var $physical_vars="Physical / License";
  var $trend_vars="Trends";
  var $alarm_vars="Alarm";
  var $signals_per_second="Signals per second";
  var $gateway_count="Number of gateways";
  var $gateway_online="Gateways online";
  var $gateway_incoming_traffic="Incoming traffic";
  var $gateway_outgoing_traffic="Outgoing traffic";
  var $gateway_incoming_traffic_per_second="Inс. traffic speed";
  var $gateway_outgoing_traffic_per_second="Outg. traffic speed";
  var $service_count="Total services";
  var $service_runnings="Running";
  var $service_errors="With errors";
  var $cpu_usage="CPU Usage";
  var $cpu_usage_avg="CPU usage, average";
  var $mem_usage="RAM Usage";
  var $mem_total="Total RAM";
  var $space_free="Free disk space";
  var $space_total="Total disk space";
  var $connections="Active connections";
  var $subscriptions="Active subscriptions";
  var $accepts="Connect counter";

  var $info="Info";
  var $control="Control";
  var $logs="Logs";
  var $name="Service";
  var $status="Status";
  var $errors="Errors";
  var $settings="Settings";
  var $service_settings="Service settings";
  var $status_running="Running";
  var $status_stopped="Stopped";
  var $status_disabled="Disabled";
  var $restart="Restart";
  var $start="Start";
  var $stop="Stop";
  var $enable="Enable";
  var $disable="Disable";
  var $control_help="Disabled services will not be started until they are enabled.<br> Stopped services will be started when the device is rebooted.";
  var $error_text="Last error";
  var $error_time="Error time";
  var $location="Location";
  var $exe="Executable file";
  var $config="Config file";
  var $delete="Delete";
  var $refresh="Refresh";
  var $nofiles="No log files";
  var $delete_confirm="Delete all log files?";
  var $reboot="Reboot";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#form{flex-grow:1}#status{flex-grow:0}#status>div{display:flex;flex-direction:row;justify-content:space-between}#status>div>div:nth-child(2){flex-shrink:0;white-space:nowrap}.slot{width:100%;height:100%;display:flex;flex-direction:column;overflow:hidden;padding:10px}.slot>*{border-radius:3px;border:1px solid var(--app-form-color);height:100%;background-color:var(--app-form-color)}a-card{--group-background-color:var(--app-header-color);--control-background-color:transparent;--border-color:var(--app-control-color)}#services{--column-background-color:var(--app-header-color);--column-border-color:var(--app-control-color);--table-background-color:var(--app-form-color);--table-border-color:var(--app-control-color)}#title{display:flex;flex-direction:row;align-items:center}#title>*{display:block}#title.running #icon{--color:var(--app-status-work-color)}#title.running #name{color:var(--app-status-work-color)}#title.error #icon{--color:var(--app-error-color)}#title.error #name{color:var(--app-error-color)}#card{margin:10px -20px -20px;border-top:solid 1px var(--app-control-color);--caption-padding:2px 20px}#help{margin-top:10px;color:var(--app-comment-color)}#icon{margin-right:10px;width:32px;height:32px;--color:var(--app-comment-color)}#name{font-size:24px;color:var(--app-comment-color)}#control{white-space:nowrap;display:flex;flex-direction:row;justify-content:space-between}#logs{white-space:nowrap;margin-top:-20px;margin-left:-20px;margin-right:-20px;padding:20px;border-bottom:solid 1px var(--app-control-color);display:flex;flex-direction:row;justify-content:space-between}#log_files{padding-top:15px}#log_files>div{display:flex;flex-direction:row;justify-content:space-between;line-height:24px;white-space:nowrap}#log_files>div a-icon{width:16px;height:16px;vertical-align:text-top}#settings{margin-top:10px}#settings>a>*{vertical-align:text-top}a-section{--padding:20px;--header-background-color:var(--app-header-color);--background-color:transparent}`,
	`<a-layout orientation="horizontal" stretch="slot2"  size1="400" store="1" id="system_layout1">
	<div class="slot"  slot="1">
		<a-card id="info"></a-card>
	</div>
	<a-layout id="content" orientation="horizontal" stretch="slot1" size2="450" store="true" slot="2">
		<div class="slot"  slot="1">
			<a-grid id='services' row_height="32"></a-grid>
		</div> 
		<div class="slot"  slot="2">
			<div id="right_info">
				<a-section id="status" caption="${$info}" store="true">
				<div>
					<div>
					<div id="title">
						<a-icon id="icon" src="/images/service_disabled.svg"></a-icon>
						<span id="name">...</span>
					</div>
					<div id="help"></div>
					</div>
					<div id="settings">
					<a id="settings_link" href="#"><a-icon width="16" src="/images/settings.svg"></a-icon> <span>${$service_settings}</span></a>
					</div>
				</div>
				<a-card id="card"></a-card>
				</a-section>
				<a-section caption="${$control}" store="true">
				<div id="control">
					<div>
					<a-button caption=${$restart} id="btn_restart"></a-button>
					<a-button caption=${$start} id="btn_start"></a-button>
					<a-button caption=${$stop} id="btn_stop"></a-button>
					</div>
					<div>
					<a-button caption=${$enable} id="btn_enable"></a-button>
					<a-button caption=${$disable} id="btn_disable"></a-button>
					</div>
				</div>
				<div class="comment mt20">${$control_help}</div>
				</a-section>
				<a-section caption="${$logs}" store="true">
				<div id="logs">
					<div>
					<a-button caption=${$refresh} id="btn_refresh_logs"></a-button>
					<a-button caption=${$enable} id="btn_enable_logs"></a-button>
					<a-button caption=${$disable} id="btn_disable_logs"></a-button>
					</div>
					<div>
					<a-button caption=${$delete} id="btn_delete_logs"></a-button>
					</div>
				</div>
				<div id="log_files"></div>
				</a-section>
			</div> 
		</div>
	</a-layout>
</a-layout>`,
);

PROPERTIES=[
	{
        key:'service',
        default:'server'
    }
];


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let infoInterval;
let services;
let selectedService;
let grid;

let statuses={
    running: $status_running,
    stopped: $status_stopped,
    disabled:$status_disabled,
};


function create(){

	pult.showPath(self,[
        [$system,'#interface/system'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/system.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system');

    infoInterval=setInterval(function (){
        updateInfo();
        updateServices();
    },990);

    


    drawServices();
    drawButtons();
    drawInfoCard();
    drawServiceCard();
    drawMenu();

    updateInfo();
    updateServices();

}

function destroy(){
    clearInterval(infoInterval);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='service')		update_service(changes[k]);
	}
}



function update_service(service){
	selectService(service);
}



function ls(str){
    let s;
    try{
        s=JSON.parse(str);
    }catch(e){
        s=str;
    }
    return locale_string(s);
}

function drawMenu(){

    let mm=[];

    let rbt;

    for(let i=0; i<schema.sysmenu.length; i++){
        let m=schema.sysmenu[i];
        if(m.path==='/system/reboot'){
            rbt=m;
        }else{
            mm.push({
                title:locale_string(m.text),
                icon:m.icon,
                href:m.href,
            });
        }
    }
    
    Util.keySort(mm,'title');
    
    mm.push('-');

    mm.push({
        text:locale_string(rbt.text),
        icon:rbt.icon,
        href:rbt.href,
    });

    pult.showTopMenu(self,mm);

}

function drawInfoCard(){

    dom.info.schema=[
        {
            key:'_version',
            caption:$version,
            group:$common,
        },
        {
            key:'_time_startup',
            caption:$time_startup,
            group:$common,
        },
        {
            key:'_time_stamp',
            caption:$time_stamp,
            group:$common,
        },
        {
            key:'physical_vars',
            format:'${physical_vars}&nbsp;/&nbsp;${license_vars}',
            caption:$physical_vars,
            group:$vars,
        },
        {
            key:'_virtual_vars',
            caption:$virtual_vars,
            group:$vars,
        },
        {
            key:'total_vars',
            caption:$total_vars,
            group:$vars,
        },
        {
            key:'trend_vars',
            caption:$trend_vars,
            group:$vars,
        },
        {
            key:'alarm_vars',
            caption:$alarm_vars,
            group:$vars,
        },
        {
            key:'_signals_per_second',
            caption:$signals_per_second,
            group:$vars,
        },
        {
            key:'gateway_count',
            caption:$gateway_count,
            group:$gateways,
        },
        {
            key:'gateway_online',
            caption:$gateway_online,
            group:$gateways,
        },
        {
            key:'_gateway_incoming_traffic',
            caption:$gateway_incoming_traffic,
            group:$gateways,
        },
        {
            key:'_gateway_outgoing_traffic',
            caption:$gateway_outgoing_traffic,
            group:$gateways,
        },
        {
            key:'_gateway_incoming_traffic_per_second',
            caption:$gateway_incoming_traffic_per_second,
            group:$gateways,
        },
        {
            key:'_gateway_outgoing_traffic_per_second',
            caption:$gateway_outgoing_traffic_per_second,
            group:$gateways,
        },

        {
            key:'service_count',
            caption:$service_count,
            group:$services,
        },
        {
            key:'service_runnings',
            caption:$service_runnings,
            group:$services,
        },
        {
            key:'service_errors',
            caption:$service_errors,
            group:$services,
        },
        {
            key:'_cpu_usage',
            caption:$cpu_usage,
            group:$resources,
        },
        {
            key:'_cpu_usage_avg',
            caption:$cpu_usage_avg,
            group:$resources,
        },
        {
            key:'_mem_usage',
            caption:$mem_usage,
            group:$resources,
        },
        {
            key:'_mem_total',
            caption:$mem_total,
            group:$resources,
        },
        {
            key:'_space_total',
            caption:$space_total,
            group:$resources,
        },
        {
            key:'_space_free',
            caption:$space_free,
            group:$resources,
        },
        {
            key:'connections',
            caption:$connections,
            group:$resources,
        },
        {
            key:'subscriptions',
            caption:$subscriptions,
            group:$resources,
        },
        {
            key:'accepts',
            caption:$accepts,
            group:$resources,
        },
    ];
}

function drawServiceCard(){
    dom.card.schema=[
        {
            key:'_status',
            caption: $status
        },
        {
            key:'_cpu_usage',
            caption: $cpu_usage
        },
        {
            key:'_cpu_usage_avg',
            caption: $cpu_usage_avg
        },
        {
            key:'_mem_usage',
            caption: $mem_usage
        },
        {
            key:'errors',
            caption: $errors
        },
        {
            key:'_error_text',
            caption: $error_text
        },
        {
            key:'_error_time',
            caption: $error_time
        },
        {
            key:'_location',
            caption: $location
        },
        {
            key:'_exe',
            caption: $exe
        },
        {
            key:'_config',
            caption: $config
        },
    ];

    dom.card.css=`.error{color:var(--app-error-color)}`;
}

function drawButtons(){
    dom.btn_restart.disabled=1;    
    dom.btn_start.disabled=1;    
    dom.btn_stop.disabled=1;    
    dom.btn_enable.disabled=1;    
    dom.btn_disable.disabled=1;    

    dom.btn_restart.onclick=function (){
        dom.btn_restart.submit_start();
        pult.request(self,'system_restart_service',{
            service:selectedService.name
        },function (req,res,err){
            setTimeout(function(){dom.btn_restart.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }
        });
    }

    dom.btn_start.onclick=function (){
        dom.btn_start.submit_start();
        pult.request(self,'system_start_service',{
            service:selectedService.name
        },function (req,res,err){
            setTimeout(function(){dom.btn_start.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }
        });
    }

    dom.btn_stop.onclick=function (){
        dom.btn_stop.submit_start();
        pult.request(self,'system_stop_service',{
            service:selectedService.name
        },function (req,res,err){
            setTimeout(function(){dom.btn_stop.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }
        });
    }

    dom.btn_disable.onclick=function (){
        dom.btn_disable.submit_start();
        let config={};
        config[selectedService.name]={enabled:0,ENABLED:0};
        pult.request(self,'system_set_config',{config:config},function (req,res,err){
            setTimeout(function(){dom.btn_disable.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }
        });
    }

    dom.btn_enable.onclick=function (){
        dom.btn_enable.submit_start();
        let config={};
        config[selectedService.name]={enabled:1,ENABLED:1};
        pult.request(self,'system_set_config',{config:config},function (req,res,err){
            setTimeout(function(){dom.btn_enable.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }
        });
    }
    
    dom.btn_refresh_logs.onclick=function (){
        dom.btn_refresh_logs.submit_start();
        updateLogFiles(selectedService,function (){
            setTimeout(function(){dom.btn_refresh_logs.submit_reset()},300);
            showInfo();
        });
    }

    dom.btn_delete_logs.onclick=function (){

        pult.showConfirm(self,$delete_confirm,function (){
            
            dom.btn_delete_logs.submit_start();
            pult.request(self,'system_delete_logs',{service:selectedService.name},function (req,res,err){
                setTimeout(function(){dom.btn_delete_logs.submit_reset()},300);
                if(err){
                    pult.showModalError(self,err);
                }else{
                    updateLogFiles(selectedService,function (){
                        showInfo();
                    });
                }
            });
        });

    }

    dom.btn_enable_logs.onclick=function (){
        dom.btn_enable_logs.submit_start();

        let s=selectedService;

        let levels=0;
        for(let k in s.config){
            if(k.startsWith('log_')){
                if(s.config[k]!=0){
                    levels++;
                }
            }
        }

        let config={};
        config[s.name]={logger_enabled:1,logger_write:1,LOG_ENABLED:1};
        if(levels==0) config[s.name].log_app=1;
        pult.request(self,'system_set_config',{config:config},function (req,res,err){
            setTimeout(function(){dom.btn_enable_logs.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }else{
                updateConfig(selectedService);
                setTimeout(function (){
                    updateLogFiles(selectedService,function (){
                        showInfo();
                    });
                },1000);
            }
        });
    }

    dom.btn_disable_logs.onclick=function (){
        dom.btn_disable_logs.submit_start();
        let config={};
        config[selectedService.name]={logger_enabled:0,LOG_ENABLED:0};
        pult.request(self,'system_set_config',{config:config},function (req,res,err){
            setTimeout(function(){dom.btn_disable_logs.submit_reset()},300);
            if(err){
                pult.showModalError(self,err);
            }else{
                updateConfig(selectedService);
            }
        });
    }
    

}

function drawServices(){

    grid=dom.services;

    let columns=[
        {
            key:'name',
            caption:$name,
            onrender:function (value,record,column,index,row,cell,refresh) {			
                let r=record;
				row.classList.toggle("online",r.status==='running');
				row.classList.toggle("offline",r.status!=='running');
				row.classList.toggle("error",!!r.errors);
                
                let href=`#interface/settings?service=${r.name}`;
                let icon='/images/services.svg';
                if      (r.status==='running') icon='/images/service_running.svg';
                else if (r.status==='stopped') icon='/images/service_stopped.svg';
                else if (r.status==='disabled') icon='/images/service_disabled.svg';
                
                cell.innerHTML=`<a-icon src="${icon}"></a-icon> ${r.name}`;
			},
        },
        {
            key:'cpu_usage',
            caption:'CPU, %',
            align:'right',
        },
        {
            key:'mem_usage',
            caption:'RAM, MB',
            align:'right',
        },
        {
            caption:$errors,
            key:'errors',
            align:'right',
        },
        {
            key:'status',
            caption:$status,
            format:{
                running:$status_running,
                stopped:$status_stopped,
                disabled:$status_disabled,
            }
        },
        {
            caption:$error_text,
            key:'_error_text',
        },
    ];

    grid.css=`.row.error,.row.error a{color:var(--app-error-color)!important}.row.error a-icon{--color:var(--app-error-color)!important}.row.online,.row.online a{color:var(--app-status-work-color)}.row.online a-icon{--color:var(--app-status-work-color)}.row.offline,.row.offline a{color:var(--app-offline-color)}.row.offline a-icon{--color:var(--app-offline-color)}.cell a:hover{color:var(--app-active-text-color)}`;
    grid.columns=columns;
    grid.onselect=function (e){
        let s=services[e.detail];
        if(s){
            self.service=s.name;
        }
    }
}

function islog(s){
    if(s && s.config){
        if(s.config.LOG_ENABLED!==undefined){
            if(s.config.LOG_ENABLED!=0){
                return true;
            }
        }else if(s.config.logger_enabled!==undefined){
            if(s.config.logger_enabled!=0 && (s.config.logger_write===undefined || s.config.logger_write!=0)){
                for(let k in s.config){
                    if(k.startsWith('log_')){
                        if(s.config[k]!=0){
                            return true;
                        }
                    }
                }
            }
        }
    }
    return false;
}


function showInfo(){
    
    let s=selectedService;
    if(!s) return;

    if(s.name==='server'){
        dom.btn_restart.disabled=0;    
        dom.btn_start.disabled=1;    
        dom.btn_stop.disabled=1;    
        dom.btn_enable.disabled=1;    
        dom.btn_disable.disabled=1;
    }else{
        dom.btn_restart.disabled=(s.status!=='running' || s.status==='disabled');    
        dom.btn_start.disabled=(s.status==='running' || s.status==='disabled');    
        dom.btn_stop.disabled=(s.status!=='running' || s.status==='disabled');    
        dom.btn_enable.disabled=(s.status!=='disabled');    
        dom.btn_disable.disabled=(s.status==='disabled' || s.status!=='running');
    }

    dom.name.innerHTML=s.name;

    if(s.status==='running') dom.icon.src='/images/service_running.svg';
    if(s.status==='stopped') dom.icon.src='/images/service_stopped.svg';
    if(s.status==='disabled') dom.icon.src='/images/service_disabled.svg';

    if(s.errors){
        dom.title.className='error';
    }else{
        dom.title.className=s.status;
    }
    
    dom.help.innerHTML= s.app && s.app.help ? ls(s.app.help) : '';
    
    dom.card.data=s;
    dom.card.update();

    dom.settings_link.href='#interface/settings?service='+s.name;

    dom.btn_enable_logs.disabled=islog(s);
    dom.btn_disable_logs.disabled=!islog(s);
    dom.btn_delete_logs.disabled=!(s.log_files && s.log_files.length);

    if(s.log_files && s.log_files.length){
        let aa=[];
        for(let i=0; i<s.log_files.length; i++){
            let f=s.log_files[i];
            aa.push(`<div><a href='/download/log/${s.name}/${f.name}'><a-icon src='/images/log.svg'></a-icon>  ${f.name}</a> <span>${Util.formatSize(f.size)}</span></div>`);
        }
        dom.log_files.innerHTML=aa.join('');
    }else{
        dom.log_files.innerHTML=`<div class='comment'>${$nofiles}</div>`;
    }

    
}

function selectService(){

    if(services){
        let service=self.__service;
        let s=services.find(function (s){
            if(s.name===service) return s;
        });
        if(!s){
            s=services.find(function (s){
                if(s.name==='server') return s;
            });
        }
        if(!s) s=services[0];
        if(s){
            selectedService=s;
            grid.select(services.indexOf(s));
            pult.request(self,'system_config_schema',{service:s.name},function (req,res,err){
                if(err){
                    pult.showModalError(self,err);
                }else{
                    s.schema=res;
                    if(s.schema && s.schema.CONFIGFACE_APP_INFO) s.app=s.schema.CONFIGFACE_APP_INFO;
                    if(s.schema && s.schema.GATEWAY_SETUP_APP_INFO) s.app=s.schema.GATEWAY_SETUP_APP_INFO;
                    if(s.schema && s.schema.SERVER_APP_INFO) s.app=s.schema.SERVER_APP_INFO;
                    updateConfig(s);
                }
            });
        }
    }

}

function updateConfig(s){
    pult.request(self,'system_config_data',{service:s.name},function (req,res,err){
        if(err){
            pult.showModalError(self,err);
        }else{
            s.config=res;
            updateLogFiles(s,function (){
                showInfo();
            });                                                        
        }
    });
}

function updateLogFiles(s,handler){
    pult.request(self,'system_log_files',{service:s.name},function (req,res,err){
        if(err){
            pult.showModalError(self,err);
        }else{
            //console.log(res);
            s.log_files=res;
            s.log_files.reverse();
            handler();
        }
    });
}

function updateServices(){
    //if(!services) return;

    pult.request(self,"system_services",null,function(req,res,err){   
        if(err){
            pult.showError(self,err);
        }else{
            //console.log(res);
            let redraw=0;
            if(!services || services.length != res.length){
                services=[];
                grid.records=services;
                redraw=1;    
            }
            for(let i=0; i<res.length; i++){
                let s=services[i]; 
                let rs=res[i];
                rs.cpu_usage=Util.round(rs.cpu_usage,1);
                rs.cpu_usage_avg=Util.round(rs.cpu_usage_avg,1);
                rs.mem_usage=Util.round(rs.mem_usage/1000,1);
                rs.errors=rs.errors?rs.errors:0;

                rs._status=statuses[rs.status];
                rs._cpu_usage=`${rs.cpu_usage}%`;
                rs._cpu_usage_avg=`${rs.cpu_usage_avg}%`;
                rs._mem_usage=`${rs.mem_usage} MB`;
                if(rs.last_error_code){
                    rs._error_text='<span class=error>'+pult.errstr({
                        code:rs.last_error_code,
                        message:rs.last_error_message
                    })+'</span>';
                    rs._error_time='<span class=error>'+Time.timestampToDateTime(rs.last_error_timestamp)+'</span>';
                }
                rs._location=Util.getFilePath(rs.path);
                rs._exe=Util.getFileName(rs.path);
                rs._config='config.cfg';

                let eq=Util.compare(s,rs);

                if(!s) services[i]=s={};
                if(!eq){
                    Util.merge(s,rs);
                    grid.refreshRow(i);
                }
            }

            if(redraw){
                selectService();
                grid.refresh();
            }
            showInfo();


        }
    }); 
}

function updateInfo(){
    pult.request(self,'system_info',null,function (req,res,err){
        if(err){
            pult.showError(self,err);
        }else{
            res._version=Util.format($version_format,res.version_number,res.version_date);
            res._mem_total=Util.formatSize(res.mem_total*1024,2);
            res._mem_usage=Util.formatSize(res.mem_usage*1024,2);
            res._space_free=Util.formatSize(res.space_free,2);
            res._space_total=Util.formatSize(res.space_total,2);
            res._gateway_incoming_traffic=Util.formatSize(res.gateway_incoming_traffic,2);
            res._gateway_outgoing_traffic=Util.formatSize(res.gateway_outgoing_traffic,2);
            res._gateway_incoming_traffic_per_second=Util.formatSize(res.gateway_incoming_traffic_per_second,2)+'/s';
            res._gateway_outgoing_traffic_per_second=Util.formatSize(res.gateway_outgoing_traffic_per_second,2)+'/s';
            res._cpu_usage=Math.round(res.cpu_usage)+"%";
            res._cpu_usage_avg=Math.round(res.cpu_usage_avg)+"%";
            res._time_startup=Time.timestampToDateTime(res.time_startup,undefined,true);
            res._time_stamp=Time.timestampToDateTime(res.time_stamp,(res.time_zone)/60,true);
            res._signals_per_second=Math.round(res.signals_per_second);
            res._virtual_vars=res.total_vars-res.physical_vars;
            dom.info.data=res;
        }
    });
}
