/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $task="Задача";
  var $plan="План";
  var $add="Добавить";
  var $delete="Удалить";
  var $clone="Клонировать";
  var $rename="Переименовать";
  var $add_plan="Добавить план";
  var $plan_letters="АБВГДЕЖЗИКЛМНОПРСТУФХЦЧШЩЪЫьЭЮЯ";
  var $plan_error_exists="Такой план уже есть";
  var $var="Переменная";
  var $set_time="Время";
  var $delete="Удалить";
  var $cancel="Отменить";
  var $save="Сохранить";
  var $clone="Клонировать";
  var $up="Переместить вверх";
  var $down="Перемесить вниз";
  var $cancel_changes="Отменить изменения?";
  var $disabled="Отключено";
  var $enabled="Включено";
  var $empty="Расписание не содержит ни одной задачи";
  
  var $clone_plan="Клонировать план";
  var $delete_plan="Удалить план";
  var $confirm_delete_plan="Удалить %s?";
  var $rename_plan="Переименовать план";
  
  var $task_name="Название<br> задачи";
  var $enable="Вкл";
  var $exec_time="Время выполнения<br> в формате CRON";
  var $exec_time_unit='с м ч ДМ М ДН';
  var $delay="Задержка<br> старта";
  var $ms="мс";
  var $vardelay="Задержка между<br> переменными";
  var $value="Задаваемое<br> значение";
  var $vars="Управляемые<br> переменные";
  var $disabled_text="Расписание отключено: задачи не выполняются";

  var $task_for_counting="задача,задачи,задач";
  var $remove_schedule='Удалить расписание?';

  var $clone_schedule='Клонировать расписание';
  var $rename_schedule='Переименовать расписание';
  var $delete_schedule='Удалить расписание';
  var $confirm_delete_schedule='Удалить расписание?';


  var $help="Универсальное расписание";
  var $help_text=`Универсальное расписание состоит из одного или нескольких планов. План содержит отдельные задачи. Задачи активного плана выполняются в указанное время. При выполнении задачи задаваемое значение записывается в управляемые переменные. 

  Задачи наследуют свои параметры от последних явно заданных. Например, можно в первой задаче определить набор переменных и все последующие задачи будут оперировать этим набором до следующего явного определения набора переменных. Так же можно поступать и с другими параметрами (время выполнения, задаваемое значение и т.д.).
  
  <h4>План</h4> Расписание может содержать один или несколько планов, например для зимнего и летнего режимов работы оборудования. При этом, каждый план может содержать свой набор задач. Выполняются только задачи активного (выбранного) плана. Задачи остальных планов игнорируются.
  
  <h4>Название задачи</h4> Произвольное имя задачи. Под данным именем задача будет отображаться в журнале после выполнения.
  
  <h4>Вкл (задача включена)</h4> Если галочка установлена - задача активна (задаваемое значение будет записываться в управляемые переменные), иначе - задача игнорируется.

  <h4>Время выполнения</h4> Задача будет выполняться в моменты времени, удовлетворяющие CRON-строке, которая состоит из шести полей, каждое поле представляет определённую единицу времени: 

  с  - секунды
  м  - минуты
  ч  - часы
  ДМ - дни месяца (числа, 1 - 31)
  М  - месяцы
  ДН - дни недели (Пн-Вс)
  
  <h4>Задаваемое значение</h4> Числовое значение, которое будет записано в управляемые переменные во время выполнения. Если переменные находятся за шлюзами, запись будет выполнена даже при разрыве связи шлюза с сервером.

  <h4>Управляемые переменные</h4> Набор переменных, в которые будет выполняться запись задаваемого значения во время выполнения задачи. Переменные при необходимости могут быть деактивированы (снимите галочку у имени переменной) - в этом случае запись задаваемого значения не будет выполняться в переменную.

  <h4>Задержка старта, мс</h4> Если указана задержка старта, задача будет выполнена с указанной задержкой относительно времени выполнения. Данную опцию можно использовать, чтобы выполнить определенную циклограмму действий.

  <h4>Задержка между переменными, мс</h4>  Если указана задержка между переменными, запись значений в переменные будет выполняться последовательно, с указанным интервалом. Даная опция позволяет разнести во времени пусковые токи мощных реактивных потребителей.
  `;

}else{

  var $task="Task";
  var $plan="Plan";
  var $add="Add";
  var $delete="Delete";
  var $clone="Clone";
  var $rename="Rename";
  var $add_plan="Add plan";
  var $plan_letters="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  var $plan_error_exists="Plan already exists";
  var $var="Variable";
  var $set_time="Time";
  var $delete="Delete";
  var $cancel="Cancel";
  var $save="Save";  
  var $clone="Clone";
  var $up="Move up";
  var $down="Move down";
  var $cancel_changes="Cancel changes?";
  var $disabled="Disabled";
  var $enabled="Enabled";
  var $empty="The schedule does not contain any tasks";
  var $rename='Rename schedule';
  var $remove='Delete schedule';


   
  var $task_name="Name<br> of the task";
  var $enable="On";
  var $exec_time="Execution<br> time in CRON format";
  var $exec_time_unit='s m h MD M WD';
  var $delay="Start<br> delay";
  var $ms="ms";
  var $vardelay="Delay between<br> variables";
  var $value="Set<br> value";
  var $vars="Controlled<br> variables";
  var $disabled_text="Schedule disabled: tasks are not running";


  var $clone_plan="Clone plan";
  var $delete_plan="Delete plan";
  var $confirm_delete_plan="Delete %s?";

  var $clone_schedule='Clone schedule';
  var $rename_schedule='Rename schedule';
  var $delete_schedule='Delete schedule';

  var $task_for_counting="task,tasks,tasks";
  var $remove_schedule='Delete schedule?';

  var $help="Universal schedule";
var $help_text=`Universal schedule consists of one or more plans. A plan contains individual tasks. The tasks of the active plan are executed at the specified time. When a task is executed, the specified value is written to the controlled variables.

Tasks inherit their parameters from the last explicitly defined ones. For example, you can define a set of variables in the first task and all subsequent tasks will operate with this set until the next explicit definition of a set of variables. You can do the same with other parameters (execution time, specified value, etc.).

<h4>Plan</h4> A schedule can contain one or more plans, for example, for winter and summer modes of equipment operation. In this case, each plan can contain its own set of tasks. Only the tasks of the active (selected) plan are executed. The tasks of other plans are ignored.

<h4>Task name</h4> An arbitrary task name. The task will be displayed in the log under this name after execution.

<h4>On (task enabled)</h4> If the checkbox is checked, the task is active (the specified value will be written to the managed variables), otherwise the task is ignored.

<h4>Execution time</h4> The task will be executed at times that satisfy the CRON string, which consists of six fields, each field representing a certain unit of time:

s - seconds
m - minutes
h - hours
MD - days of the month (numbers, 1 - 31)
M - months
WD - days of the week (Mon-Sun)

<h4>Specified value</h4> A numeric value that will be written to the managed variables during execution. If the variables are behind gateways, the writing will be performed even if the gateway connection to the server is broken.

<h4>Controlled variables</h4> A set of variables to which the specified value will be written during task execution. Variables can be deactivated if necessary (uncheck the variable name) - in this case, the specified value will not be written to the variable.

<h4>Start delay, ms</h4> If a start delay is specified, the task will be executed with the specified delay relative to the execution time. This option can be used to execute a certain cyclogram of actions.

<h4>Delay between variables, ms</h4> If a delay between variables is specified, values ​​will be written to variables sequentially, with the specified interval. This option allows you to spread out the starting currents of powerful reactive consumers in time.
`;


}

(function (){
    
    window.base64_decode=function(base64string) { // base64 string to arrayBuffer
        var binaryString = (base64string!==null && base64string!=='') ? atob(base64string) : '';
        var bytes = new Uint8Array(binaryString.length);
        for (var i = 0; i < binaryString.length; i++) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        return bytes.buffer;
    }


    window.base64_encode=function(arrayBuffer) { // arrayBuffer to base64 string
        
        var base64    = ''
        var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
      
        var bytes         = new Uint8Array(arrayBuffer)
        var byteLength    = bytes.byteLength
        var byteRemainder = byteLength % 3
        var mainLength    = byteLength - byteRemainder
      
        var a, b, c, d
        var chunk
      
        // Main loop deals with bytes in chunks of 3
        for (var i = 0; i < mainLength; i = i + 3) {
          // Combine the three bytes into a single integer
          chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2]
      
          // Use bitmasks to extract 6-bit segments from the triplet
          a = (chunk & 16515072) >> 18 // 16515072 = (2^6 - 1) << 18
          b = (chunk & 258048)   >> 12 // 258048   = (2^6 - 1) << 12
          c = (chunk & 4032)     >>  6 // 4032     = (2^6 - 1) << 6
          d = chunk & 63               // 63       = 2^6 - 1
      
          // Convert the raw binary segments to the appropriate ASCII encoding
          base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d]
        }
      
        // Deal with the remaining bytes and padding
        if (byteRemainder == 1) {
          chunk = bytes[mainLength]
      
          a = (chunk & 252) >> 2 // 252 = (2^6 - 1) << 2
      
          // Set the 4 least significant bits to zero
          b = (chunk & 3)   << 4 // 3   = 2^2 - 1
      
          base64 += encodings[a] + encodings[b] + '=='
        } else if (byteRemainder == 2) {
          chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1]
      
          a = (chunk & 64512) >> 10 // 64512 = (2^6 - 1) << 10
          b = (chunk & 1008)  >>  4 // 1008  = (2^6 - 1) << 4
      
          // Set the 2 least significant bits to zero
          c = (chunk & 15)    <<  2 // 15    = 2^4 - 1
      
          base64 += encodings[a] + encodings[b] + encodings[c] + '='
        }
        
        return base64
    }
})();



PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#_interface_content{overflow:hidden!important}#plans{display:flex;flex-direction:row;justify-content:space-between;border-bottom:solid 1px var(--app-grid-header-border-color)}#plans .plan{padding:5px 20px;cursor:pointer}#plans .plan.selected{background-color:var(--app-grid-header-color);color:var(--app-active-text-color)}#plan_tabs{display:flex;flex-direction:row}#plan_buttons{display:flex;align-items:center;flex-direction:row;padding:0 10px}#plan_buttons a-icon{margin-left:5px;width:20px;height:20px;--color:var(--app-text-color);padding:2px;cursor:pointer}#plan_buttons a-icon:hover{--color:var(--app-active-text-color)}#disabled{padding:10px 20px;background-color:var(--app-offline-color);color:var(--app-active-text-color);text-align:center;display:none}a-layout{flex-grow:1}#help{padding:20px;border-bottom:solid 1px var(--app-control-color)}#help>div{white-space:pre-line}#empty{flex-grow:1}#container{overflow:hidden;display:flex;flex-direction:column;min-height:50%;border-bottom:solid 1px var(--app-control-color)}#columns{overflow:hidden;width:100%;flex-shrink:0;background-color:var(--app-grid-header-color);white-space:nowrap;display:flex;flex-direction:row;border-bottom:solid 1px var(--app-grid-header-border-color);padding-right:20px}#columns>div{flex-shrink:0;padding:15px;border-right:solid 1px var(--app-grid-header-border-color)}#columns>div:last-child{border-right:none}#columns>div>div:first-child{margin-bottom:5px}#columns>div>div:nth-child(2){color:var(--app-comment-color)}#tasks{height:100%;flex-grow:0;overflow:auto}#tasks>div{white-space:nowrap;display:flex;flex-direction:row;border-bottom:solid 1px var(--app-grid-header-border-color)}#tasks>div.disabled>div>*{opacity:.3}#tasks>div.selected{background-color:var(--app-selected-color)}#tasks>div.selected>div.selector{background-color:transparent}#tasks>div>div{flex-shrink:0;padding:1px;border-right:solid 1px var(--app-grid-header-border-color)}#tasks>div>div:last-child{border-right:none}#tasks>div>div.selector{background-color:var(--app-grid-header-color)}#tasks>div>div.wrap{white-space:normal}#tasks>div>div>a-edit{--padding:10px 15px;--border-radius:0;--background-color:transparent;--justify-content:start;max-width:none}#tasks>div>div>a-edit:focus{--background-color:var(--app-background-color)}#tasks>div>div>span{display:inline-block;padding:10px 15px}#tasks>div>div>span.undef{color:var(--app-comment-color)}#tasks>div>div>a-checkbox{margin:12px 15px 10px}#tasks>div>div>a-pult-vars{padding:10px 15px;overflow:hidden;--selected-color:var(--app-selected-color)}`,
	`<div id="pult_header">
	<div class="pult_split pult_sep" id="button_bar">
	  <div class="pult_buttons">
	  	<a-button id='btn_add_task' icon="/images/add.svg" caption='${$task}'></a-button>
		<hr>
		<a-button id='btn_clone' icon="/images/clone.svg" disabled="1" title='${$clone}'></a-button>
		<a-button id='btn_up' icon="/images/move_up.svg" disabled="1" title='${$up}'></a-button>
		<a-button id='btn_down' icon="/images/move_down.svg" disabled="1" title='${$down}'></a-button>
		<hr>
		<a-button id='btn_delete' icon="/images/del.svg" disabled="1" hotkey="DELETE"  caption='${$delete}'></a-button>
	</div>	
	<div class="pult_buttons">
		<a-select id="sel_enabled"></a-select>
		<hr>
		<a-button id='btn_save' disabled="1" hotkey="Ctrl+S" palette="anode-button-active" caption='${$save}'></a-button>
		<a-button id='btn_cancel' disabled="1"  caption='${$cancel}'></a-button>
		<hr>
		<a-button id='btn_menu' icon="/images/dotmenu.svg"></a-button>
		<a-button id='btn_help' icon="/images/help.svg"></a-button>
	  </div>
	</div> 
</div>
<div id="disabled">${$disabled_text}</div>

<a-layout id="layout" orientation="horizontal" stretch="slot1" size2="300" store="true" >
	<div id="container" slot="1">
		<div id="plans">
			<div id="plan_tabs"></div>
		</div>
		<div id="columns"></div>
		<div id="tasks"></div>
		<div id="empty" class="pult_empty">${$empty}</div>
	</div>
	<div id="help" class="pult_big_help" slot="2">
		<h3>${$help}</h3>
		<div>${$help_text}</div>
	</div>
</a-layout>

`,
);


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let interval;
let selection=[];
let content;
let data;
let plan;
let plans;
let selobjects=[];
let seltype;
let seldata;
let tasks;
let lastCol;
let lastRow;
let selvar_in_process;

const COLUMNS=[
    {
        key:'_selector',
        caption:"",
        classes:['selector'],
    },
    {
        key:'name',
        caption:$task_name,
        draw:drawInput,
        maxwidth:160,
        wrap:true,
        defdown:false,
    },
    {
        key:'enabled',
        caption:$enable,
        defdown:false,
        draw:drawCheckbox,
    },
    {
        key:'cron',
        caption:$exec_time,
        unit:$exec_time_unit,
        draw:drawInput,
        formfunc: showTime,
    },
    {
        key:'value',
        caption:$value,
        draw:drawInput,
    },
    {
        key:'vars',
        caption:$vars,
        draw:drawVars,
        defdown:true,
        wrap:true,
        grow:true,
    },
    {
        key:'delay',
        caption:$delay,
        unit:$ms,
        draw:drawInput,
    },
    {
        key:'vardelay',
        caption:$vardelay,
        unit:$ms,
        draw:drawInput,
    },
];

function create(){

    tasks=dom.tasks;

    let lastWidth;

    interval=setInterval(function (){
        // alignColumns();
        if(dom.container.offsetWidth!==lastWidth){
            lastWidth=dom.container.offsetWidth;
            requestAnimationFrame(alignColumns);
        }
    },300);

    dom.sel_enabled.list=[
        [0,$disabled],
        [1,$enabled],
    ];
    dom.sel_enabled.onchange=function (e){
        content.enabled=Number(this.value);
        needSave(true);
    }

    dom._interface_content.tabIndex=0;
    dom._interface_content.onkeydown=function (e){

        if(lastRow!==undefined){
            if(e.key==='ArrowUp'){
                let ri=lastRow-1;
                if(ri<0) ri=0;
                unselect();
                select(ri);
                if(lastCol!==undefined){
                    let row=tasks.children[ri];
                    let cell=row.children[lastCol];
                    if(cell) cell.children?.[0]?.focus();
                }
            }else if(e.key==='ArrowDown'){
                let ri=lastRow+1;
                if(ri>=data.length) ri=data.length-1;
                unselect();
                select(ri);
                if(lastCol!==undefined){
                    let row=tasks.children[ri];
                    let cell=row.children[lastCol];
                    if(cell) cell.children?.[0]?.focus();
                }
            // }else if(e.key==='ArrowLeft'){
            //     if(lastRow!==undefined && lastCol>0){
            //         lastCol--;
            //         let row=tasks.children[lastRow];
            //         let cell=row.children[lastCol];
            //         if(cell) cell.children?.[0]?.focus();
            //     }
            // }else if(e.key==='ArrowRight'){
            //     if(lastRow!==undefined && lastCol<COLUMNS.length-1){
            //         lastCol++;
            //         let row=tasks.children[lastRow];
            //         let cell=row.children[lastCol];
            //         if(cell) cell.children?.[0]?.focus();
            //     }
            }

        }
    }

    dom._interface_content.onmousedown=function (){
        unselectVars();
        unselect();
    }
    tasks.onmousedown=function (e){
        e.stopPropagation();
    }

    tasks.onscroll=function (e){
        dom.columns.scrollLeft=tasks.scrollLeft;
    }

    dom.columns.onmousewheel=function (e){
        tasks.scrollLeft+=e.deltaY;
    }


    dom.btn_save.onclick=function (e){
        pult.fdb.saveJsonDoc(self,self.path,'@content.json',content,function (req,res,err){
            if(err){
                pult.showModalError(self,err);
            }else{
                needSave(false);
                refreshEnabled();
            }
        });
    }

    dom.btn_cancel.onclick=function (e){
        pult.showConfirm(self,$cancel_changes,function (e){
            needSave(false);
            loadContent();
        });
    }

    dom.btn_add_task.onclick=function (e){
        let cron;
        let names=[];
        for(let i=0; i<data.length; i++){
            let r=data[i];
            if(r.name) names.push(r.name);
        }
        if(!data.length){
            cron='0 0 12 * * *';
        }
        data.push({
            name:Util.getNextName($task,names),
            cron:cron,
            enabled:true,
        });
        refresh();
        select(data.length-1);
        needSave(true);
    }

    dom.btn_delete.onclick=function(e){
        if(seltype==='tasks'){
            let j=0;
            selection.sort(function(a, b){return a - b;});
            for(let i=selection.length-1; i>=0; i--){
                j=selection[i];
                data.splice(j,1);
            }
            unselect();
            refresh();

            if(j>=data.length) j=data.length-1;
            if(j>=0) select(j);
            needSave(true);
        }else if(seltype==='vars'){
            let c=seldata;
            c.delete(selobjects);            
        }
    }

    dom.btn_clone.onclick=function(e){
        if(seltype==='tasks'){
            selection.sort(function(a, b){return a - b;});
            console.log(selection);
            let cnt=data.length;
            for(let i=0; i<selection.length; i++){
                let j=selection[i];
                console.log(j);
                let r=data[j];
                data.push(Util.clone(r));
            }
            refresh();
            for(let i=cnt; i<data.length; i++){
                select(i);
            }
            needSave(true);
        }else if(seltype==='vars'){

        }
    }
    
    dom.btn_up.onclick=function(e){
        if(seltype==='tasks'){
            moveSelectedUpDown(data,selection,-1);
            drawTasks();
            alignColumns();
        }
    }

    dom.btn_down.onclick=function(e){
        if(seltype==='tasks'){
            moveSelectedUpDown(data,selection,1);
            drawTasks();
            alignColumns();
        }
    }
    
    dom.btn_help.onclick=function (){
        dom.layout.toggle(2);
    }
    
}


function createPlan(planData){
    let name=getActivePlan()?.name;
    let repl=false;
    for(let i=$plan_letters.length-1; !repl && i>=0; i--){
        let l=$plan_letters[i];
        for(let j=0; !repl && j<content.plans.length; j++){
            let p=content.plans[j];
            if(p.name.endsWith(' '+l)){
                i=i+1;
                if(i>=$plan_letters.length) i=0;
                l=$plan_letters[i];
                name=name.substring(0,name.length-2)+' '+l;
                repl=true;
            }
        }
    }

    if(!repl){
        name=Util.getNextName(name,Object.keys(content.plans));
    }

    let f=pult.showForm(self,{
        caption:$add_plan,
        submitFocus:false,
        html:[
            {
                tag:'a-input',
                value:name,
                name:'name',
                set_focus:true,
                properties:{
                    validation_events:'submit',
                    validation:[
                        'notEmpty',
                        {
                            method:function (v){
                                if(content.plans.find(function (p){
                                    if(p.name===v) return true;
                                })){
                                    return $plan_error_exists;
                                }
                            }
                        }
                    ],
                }
            }
        ],
        onsubmit:function (e){
            let name=e.detail.name.trim();
            let data=Util.def({
                name:name,
            },planData);
            content.plans.push(data);
            redrawPlans();
            redrawMenu();                
            selectPlan(name);                
        }
    });

    
}

function destroy(){
    clearInterval(interval);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}


function update_path(path){
    pult.showObject(self,self.path,null,function (o){
        loadContent();
    });
}

function loadContent(){
    
    unselect();
    unselectVars();

    pult.fdb.loadDoc(self,self.path,{
        file:'@content.json',
        format:'json',
    },function (req,res,err){
        if(err && err.code!==FDB_ERROR_DOC_NOT_FOUND){
            pult.showModalError(self,err);
        }else{
            content=Util.def(res?.data,pult.defaultSchedule);
            if(!content.plans) content.plans=pult.defaultSchedule.plans;
            if(!content.settings) content.settings=pult.defaultSchedule.settings;
            if(!content.vars) content.vars=[];
            if(!content.vardelay) content.vardelay=0;
            redrawPlans();
            redrawMenu();
            selectPlan();
        }
    });
}

function selectPlan(plan){
    if(!plan){
        plan=getActivePlan()?.name;
    }
    let curPlan=getActivePlan()?.name;

    if(curPlan!==plan){
        needSave(true);
    }

    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        p.active=false;
    }

    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.name===plan){
            p.active=true;
            break;
        }
    }

    for(let i=0; i<dom.plan_tabs.children.length; i++){
        let n=dom.plan_tabs.children[i];
        if(n.plan===plan){
            n.classList.add('selected');
        }else{
            n.classList.remove('selected');
        }
    }

    let p=getActivePlan();
    if(!p.tasks) p.tasks=[];
    data=p.tasks;

    redrawData();
}

function getActivePlan(){
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.active) return p;
    }
    return content.plans[0];
}

function getActivePlanIndex(){
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        if(p.active) return i;
    }
    return 0;
}


function redrawPlans(){

    dom.plan_tabs.innerHTML='';
    for(let i=0; i<content.plans.length; i++){
        let p=content.plans[i];
        let n=document.createElement('div');
        n.classList='plan';
        n.innerHTML=p.name;
        n.plan=p.name;
        dom.plan_tabs.appendChild(n);
        n.onclick=function (e){
            selectPlan(n.plan);
        }
    }

}

function redrawMenu(){
    let menu=[];
    
    menu.push({
        caption:$add_plan,
        onclick:function (){
            createPlan();
        }
    });
    
    menu.push({
        caption:$clone_plan,
        onclick:function (){
            let p=getActivePlan();
            createPlan(p);
        }
    });

    menu.push({
        caption:$rename_plan,
        onclick:function (){
            let f=pult.showForm(self,{
                caption:$rename_plan,
                submitFocus:false,
                html:[
                    {
                        tag:'a-input',
                        value:getActivePlan()?.name,
                        name:'name',
                        set_focus:true,
                        properties:{
                            validation_events:'submit',
                            validation:[
                                'notEmpty',
                                {
                                    method:function (v){
                                        if(content.plans.find(function (p){
                                            if(p.name===v) return true;
                                        })){
                                            return $plan_error_exists;
                                        }
                                    }
                                }
                            ],
                        }
                    }
                ],
                onsubmit:function (e){
                    let name=e.detail.name.trim();
                    let pp={};
                    let p=getActivePlan();
                    p.name=name;
                    redrawPlans(); 
                    redrawMenu();               
                    selectPlan(name);                
                }
            });
        }
    });

    if(content.plans.length>=2){
        menu.push({
            caption:$delete_plan,
            onclick:function (){
                pult.showConfirm(self,Util.format($confirm_delete_plan,getActivePlan()?.name),function(){
                    let i=getActivePlanIndex();
                    console.log(i);
                    content.plans.splice(i,1);
                    needSave(true);
                    redrawPlans();
                    redrawMenu();
                    selectPlan(getActivePlan()?.name);
                });
            }
        });
    }

    menu.push("-");

    
    menu.push({
        caption:$clone_schedule,
        onclick:function (){
            pult.request(self,'fdb_nextname',{
                path:self.path
            },function (req,res,err){
                if(err){
                    pult.showError(self,err);
                }else{
                    path=res;
                    let name=Util.getFileTitle(path);
                    let f=pult.showForm(self,{
                        caption:$clone_schedule,
                        width:400,
                        submitFocus:false,
                        html:[
                            {
                                tag:'a-input',
                                value:name,
                                width:'100%',
                                name:'name',
                                set_focus:true,
                                validation:['fileName'],
                            },
                        ],
                        onsubmit:function (e){
                            let name=e.detail.name;
                            let dest=Util.getFilePath(self.path) + '/' + name + '.schedule';
                        
                            pult.fdb.copy(self,{
                                path:self.path,
                                dest:dest,
                            },function (req,res,err){
                                if(err){
                                    pult.showError(self,err);
                                    f.show();
                                }else{
                                    pult.navigate(`#interface/simple_schedule?path=${dest}`);
                                }
                            });
                        }
                    });                
                }
            });
        }
    });

    menu.push({
        caption:$rename_schedule,
        onclick:function (){
            let f=pult.showForm(self,{
                caption:$rename_schedule,
                width:400,
                submitFocus:false,
                html:[
                    {
                        tag:'a-input',
                        value:Util.getFileTitle(self.path),
                        width:'100%',
                        name:'name',
                        set_focus:true,
                        validation:['fileName'],
                    },
                ],
                onsubmit:function (e){
                    let name=e.detail.name;
                    let dest=Util.getFilePath(self.path) + '/' + name + '.schedule';
                   
                    pult.fdb.move(self,{
                        path:self.path,
                        dest:dest,
                    },function (req,res,err){
                        if(err){
                            pult.showError(self,err);
                            f.show();
                        }else{
                            pult.navigate(`#interface/simple_schedule?path=${dest}`);
                        }
                    });
                }
            });                
        }
    });


    menu.push({
        caption:$delete_schedule,
        onclick:function (e){
            pult.showConfirm(self,$confirm_delete_schedule,function (){
                pult.request(self,'fdb_delete',{
                    path:self.__path,
                },function (req,res,err){
                    if(err){
                        pult.showError(self,err);
                    }else{
                        let pp=Util.getFilePath(self.__path);
                        pult.navigate(`#interface/schedules?path=${pp}`);
                    }
                });
            });
        }
    });


    dom.btn_menu.popmenu=menu;
}

function refresh(){
    drawTasks(data);
    unselect();
    alignColumns();
}

function redrawData(){
    refreshEnabled();
    drawColumns();
    drawTasks(data);
    alignColumns();
}

function refreshEnabled(){
    self.status = content.enabled ? 2 : 0;
    dom._interface_status.style.display='none';
    dom.sel_enabled.value=content.enabled;
    if(content.enabled){
        dom.disabled.style.display='none';
    }else{
        dom.disabled.style.display='block';
    }
}



function drawColumns(){
    let cc=dom.columns;
    cc.innerHTML='';
    for(let i=0; i<COLUMNS.length; i++){
        let c=COLUMNS[i];
        let d=document.createElement('div');
        d.innerHTML=`
        <div>${c.caption}</div>
        <div>${c.unit || ''}</div>
        `;
        cc.appendChild(d);
    }
}

function drawText(cell,val,placeholder,onchange){
    let c=document.createElement('span');
    if(val===undefined){
        val=placeholder;
        c.classList.add('undef');
    }
    c.innerHTML=val;
    cell.appendChild(c);
    return c;
}

function drawInput(cell,val,placeholder,onchange){
    
    let c=document.createElement('a-edit');
    c.placeholder=placeholder;
    c.value=val;
    c.formfunc=this.formfunc;
    cell.appendChild(c);
    c.onchange=function (){
        onchange(c.value);
    }
    return c;
}

function drawCheckbox(cell,val,placeholder,onchange){
    let c=document.createElement('a-checkbox');
    c.value=val;
    cell.appendChild(c);
    c.onmousedown=function (e){
        e.stopPropagation();
    }
    c.onchange=function (){
        onchange(c.value);
    }
    return c;
}

function drawVars(cell,val,placeholder,onchange){
    let c=document.createElement('a-pult-vars');

    c.value=val;
    c.placeholder=placeholder;
    c.current_project=pult.getProjectPath(self.__path);
    c.current_widget=self;
    
    c.formfunc=function (e){
        showAddVar();
    }
    cell.appendChild(c);
    c.onselect=function (){
        if(!selvar_in_process){
            selvar_in_process=true;
            unselect();
            selectVars(c);
            selvar_in_process=false;
        }
    }
    c.onchange=function (){
        onchange(c.value);
    }
    c.onvarenabled=function (){
        
    }
    c.onvardisabled=function (){
        
    }

    return c;
}

function drawTasks(){

    if(data.length){
        dom.empty.style.display='none';
        dom.tasks.style.display='';
    }else{
        dom.tasks.style.display='none';
        dom.empty.style.display='';
    }

    let rr=tasks;
    let scroll=rr.scrollTop;
    rr.innerHTML='';
    let defs={};
    for(let i=0; i<data.length; i++){
        let r=data[i];
        let row=document.createElement('div');
        row.onmousedown=function (e){
            unselectVars();
            let j=selection.indexOf(i);
            //if(j<0){
                if(!e.ctrlKey) unselect();
                select(i);
            //}else{
                //unselect(i);
            //}
        }
        for(let j=0; j<COLUMNS.length; j++){
            let c=COLUMNS[j];
            let cell=document.createElement('div');
            cell._rowIndex=i;
            cell._colIndex=j;
            if(c.wrap) cell.classList.add('wrap');
            if(c.classes){
                for(let i=0; i<c.classes.length; i++){
                    let cls=c.classes[i];
                    cell.classList.add(cls);
                }
            }
            let val=r[c.key];
            let placeholder=defs[c.key];
            if(placeholder===undefined) placeholder='—';
            if(c.draw){
                
                cell.onmousedown=function (e){
                    lastCol=j;
                }

                cell.control=c.draw(cell,val,placeholder,function (v){
                    r[c.key]=v;
                    needSave(true);
                    if(c.key==='enabled'){
                        refreshTaskEnabled(i);
                    }

                    if(c.defdown!==false){
                        let ph=Util.clone(placeholder);
                        if(v!==undefined) ph=Util.clone(v);

                        
                        for(let k=i+1; k<data.length; k++){
                            let row=rr.children[k];
                            let cell=row.children[j];
                            if(cell.control.value===undefined){
                                cell.control.placeholder=ph;
                            }else{
                                break;
                            }
                        }
                    }
                    requestAnimationFrame(function (){
                        alignColumns();
                    });
                });
            }
            if(val!==undefined && c.defdown!==false) defs[c.key]=val;
            row.appendChild(cell);
        }
        if(selection.includes(i)) row.classList.add('selected');
        rr.appendChild(row);
        refreshTaskEnabled(i);
    }
    rr.scrollTop=scroll;
}

function refreshTaskEnabled(i){
    let r=data[i];
    let row=tasks.children[i];
    row.classList.toggle('disabled',!r.enabled);
}

function alignColumns(){
    let cc=[];
    let columns=dom.columns;
    let growIndex=-1;
    
    let scrollTop=tasks.scrollTop;

    for(let i=0; i<columns.children.length; i++){
        let c=columns.children[i];
        c.style.width=``;
    }

    for(let j=0; j<tasks.children.length; j++){
        let r=tasks.children[j];
        r.style.minWidth=``;
        for(let i=0; i<r.children.length; i++){
            let c=r.children[i];
            c.style.width=``;
        }
    }

    for(let i=0; i<columns.children.length; i++){
        let col=COLUMNS[i];
        let c=columns.children[i];
        if(col.grow){
            growIndex=i;
        }else{
            cc[i]=c.offsetWidth;
        }
    }
    
    for(let i=0; i<tasks.children.length; i++){
        let r=tasks.children[i];
        for(let i=0; i<r.children.length; i++){
            let col=COLUMNS[i];
            if(!col.grow){
                let c=r.children[i];
                let ow=c.offsetWidth;
                if(ow>cc[i]) cc[i]=ow;
            }
        }
    }

    let total=0;
    let lastw=0;
    for(let i=0; i<cc.length; i++){
        let col=COLUMNS[i];
        if(!col.grow){
            if(col.maxwidth && cc[i] > col.maxwidth) cc[i]=col.maxwidth;
            total+=cc[i];
        }
    }

    grow=dom.container.offsetWidth-total;
    if(grow<=200) grow=200;
    total+=grow;
    cc[growIndex]=grow;
    
    //columns.style.minWidth=`${total}px`;
    for(let i=0; i<cc.length; i++){
        let w=cc[i];
        let c=columns.children[i];
        c.style.width=`${w}px`;
    }

    for(let j=0; j<tasks.children.length; j++){
        let r=tasks.children[j];
        r.style.minWidth=`${total}px`;
        for(let i=0; i<cc.length; i++){
            let w=cc[i];
            let c=r.children[i];
            c.style.width=`${w}px`;
        }
    }

    tasks.scrollTop=scrollTop;

}



function selectVars(c){
    let vv=tasks.querySelectorAll('a-pult-vars');
    for(let i=0; i<vv.length; i++){
        let v=vv[i];
        if(v===c){
            if(v.selection.length){
                let oo=[];
                for(let i=0; i<v.selection.length; i++){
                    oo.push(v.selection[i]);
                }
                selectObjects('vars',oo,v);
            }
        }else{
            v.unselect();
        }
    }
}

function unselectVars(){
    let changed=false;
    let vv=tasks.querySelectorAll('a-pult-vars');
    for(let i=0; i<vv.length; i++){
        let v=vv[i];
        if(v.selection.length){
            changed=true;
            v.unselect();
        }
    }
    if(changed) unselectObjects();
}

function unselect(indexes){
    let self=this;
    if(indexes===undefined){
        indexes=[];
        for(let i=0; i<tasks.children.length; i++){
            indexes.push(i);
        }
    }
    if(!Array.isArray(indexes)) indexes=[indexes];
    for(let j=0; j<indexes.length; j++){
        let i=indexes[j];
        let r=tasks.children[i];
        if(r){
            let j=selection.indexOf(i);
            if(j>=0){
                selection.splice(j,1);
                r.classList.remove('selected');
            }
        }
    }
    if(!selection.length){
        lastRow=undefined;
        unselectObjects();
    }
}

function select(indexes){
    let self=this;
    if(indexes===undefined) return;
    if(!Array.isArray(indexes)) indexes=[indexes];
    for(let j=0; j<indexes.length; j++){
        let i=indexes[j];
        let r=tasks.children[i];
        lastRow=i;
        if(r){
            if(!selection.includes(i)){
                selection.push(i);
                r.classList.add('selected');
            }
        }
    }
    if(selection.length){
        let oo=[];
        for(let i=0; i<selection.length; i++){
            oo.push(data[selection[i]]);
        }
        selectObjects('tasks',oo);
    }
}


function selectObjects(type,oo,data){
    if(!selobjects.length){
        seltype=type;
        selobjects=oo;
        seldata=data;
    }
    refreshButtons();
}

function unselectObjects(){
    if(selobjects.length){
        selobjects=[];
        seltype=null;
        seldata=null;
    }
    refreshButtons();
}

function refreshButtons(){
    if(seltype==='tasks'){
        dom.btn_add_task.disabled=false;
        dom.btn_delete.disabled=false;
        dom.btn_clone.disabled=false;
        dom.btn_up.disabled=false;
        dom.btn_down.disabled=false;
    }else if(seltype=='vars'){
        dom.btn_add_task.disabled=true;
        dom.btn_delete.disabled=false;
        dom.btn_clone.disabled=true;
        dom.btn_up.disabled=true;
        dom.btn_down.disabled=true;
    }else{
        dom.btn_add_task.disabled=false;
        dom.btn_delete.disabled=true;
        dom.btn_clone.disabled=true;
        dom.btn_up.disabled=true;
        dom.btn_down.disabled=true;
    }
}

function needSave(need){
    pult.needSave=need;
    dom.btn_save.disabled=!need;
    dom.btn_cancel.disabled=!need;
}

function moveSelectedUpDown(data,selection,dir){ // down: dir=1, up: dir=-1
    let self=this;
    let n=0;
    if(dir<0){
        selection.sort((a, b) => (a < b ? -1 : 1));
    }else{
        selection.sort((a, b) => (a > b ? -1 : 1));
    }
    for(let i=0; i<selection.length; i++){
        let r1=selection[i];
        let r2=r1+dir;
        if(r2>=data.length || r2<0){
            return;
        }else{
            n++;
            let rec1=data[r1];
            let rec2=data[r2];
            data[r2]=rec1;
            data[r1]=rec2;
            selection[i]=r2;
        }
    }
    return n;
}


function getLastValue(ri,col){
    for(let i=ri; i>=0; i--){
        let r=data[i];
        if(r[col]!==undefined) return r[col];
    }
}



function showTime(){
    let ri=selection[0];
    let cronStr=getLastValue(ri,'cron');
    pult.showCron(self,cronStr,function (cronStr){
        data[ri].cron=cronStr;  
        drawTasks(data);
        alignColumns();
        needSave(true);
    });
}

function showAddVar(){
    let ri=selection[0];
    let cronStr=getLastValue(ri,'cron');
    pult.showSelectVar(self,function (v){
        let vn=v.sameProject ? v.projectName : v.globalName;
        console.log(vn);
        let r=data[ri];
        if(!r.vars) r.vars=[];
        if(!r.vars.find(function (v){
            if(v.name===vn) return true;
        })){
            r.vars.push({enabled:true,name:vn});
            drawTasks(data);
            alignColumns();
            needSave(true);
        }
    });
}

